-- Project StreetzRPG: command and debug script - "cscript"
-- Author: Bryan Mader
cscript = {}
cscript.nominal = true

function cscript.runcmd(command)
	svc.lastcmd = command
	local cmdisvalid = false
	n.talkingto = nil
	local returned = false
	msg.box = false
	msg.boxmsg = ""
	if command:sub(1, 1) == "/" then -- COMMAND SYMBOL
	local cmd = string.gsub(command, "/", "", 1)
	--	 DEVMODE BLACKLIST
	if (string.find(cmd, "set") or string.find(cmd, "ctest") or string.find(cmd, "ctest2") or string.find(cmd, "day") or string.find(cmd, "night") or string.find(cmd, "revive") or string.find(cmd, "run") or (string.find(cmd, "get") and not (string.find(cmd, "target"))) or string.find(cmd, "find")) and n.devmode == false then
		append(color.gray, "You are not in devmode.")
		return
	end
		if cmd == "cmds" then
			append(color.lgray, "[COMMAND LIST] /cmds, /equip, /stats, /call, /use, /chat, /credits")
			append(color.lgray, "[CONT.] /clear, /snuffcig, /reply, /rob, /robbery, /target, /inv")
			append(color.lgray, "[CONT.] /buydrug, /offerdrug, /q, /log, /save, /load, /enter, /exit")
			append(color.lgray, "[CONT.] /car, /reload, /priceweed, /pricecoke, /fish, /bucket")
			append(color.lgray, "[CONT.] /travel, /radio, /upshift, /downshift")
			append(color.lblue, "[DEV CMDS] /set, /revive, /devmode, /run, /day, /night, /hurt, /mute")
			append(color.lblue, "[DEV CMDS] /v, /get, /devtags, /get, /find, /mpos, /color /ctest, /ctest2")
			if player.factionid == 1 then append(color.blue, "Police commands: /arrest, /(stop)drag, /uncuff, /duty, /fcar"); append(color.blue, "[coming soon] /siren, /jail") end
			if player.factionid == 2 then append(color.dred, "Fire Dept. commands: /duty, /fcar [coming soon] /heal, /stretcher, /admit") end
			if player.factionid == 6 then append(color.yellow, "Trucker commands: [coming soon] /truck, /fuelrun, /restock") end
			cmdisvalid = true
		end
		-- MPOS
		if cmd == "mpos" then
			cmdisvalid = true
			if n.mpos == false then
				append(color.lblue, "Mouse position enabled.")
				n.mpos = true
				return
			end
			if n.mpos == true then
				append(color.red, "Mouse position hidden.")
				n.mpos = false
			end
		end
		
		-- RUN
		if string.find(cmd, "run") then
			cmdisvalid = true
			if cmd == "run updaterank" then updaterank(); append(color.lblue, "Running updaterank()") end
			if cmd == "run updatetags" then updatetags(); append(color.lblue, "Running updatetags()") end
			if cmd == "run spawn" then spawn(); append(color.lblue, "Running spawn()") end
			if cmd == "run summon cop" then summon("cop"); append(color.lblue, "Running summon('cop')") end
			if cmd == "run summon emt" then summon("emt"); append(color.lblue, "Running summon('emt')") end
			if cmd == "run paycheck" then paycheck(); append(color.lblue, "Running paycheck()") end
			if string.find(cmd, "run targethit") then dmg = string.match(cmd, "%d+"); targethit(dmg); append(color.lblue, "Running targethit("..dmg..")") end
			if string.find(cmd, "run playerhit") then dmg = string.match(cmd, "%d+"); playerhit(dmg); append(color.lblue, "Running playerhit("..dmg..")") end
			if cmd == "run checktarget" then checktarget(); append(color.lblue, "Running checktarget()") end
			if cmd == "summon cop" then summon("cop"); append(color.lblue, "Running summon(cop)") end
			if cmd == "summon emt" then summon("emt"); append(color.lblue, "Running summon(emt)") end
			if string.find(cmd, "run xp") then
				local amount = tonumber(string.match(cmd, "%d+"))
				append(color.lblue, "Running xp("..amount..")")
				xp(amount)
			end
			if string.find(cmd, "run placenpcs") then
					local d = tonumber(string.match(cmd, "%d+"))
					placenpcs(d)
					append(color.lblue, "Running placenpcs("..d..")")
			end
			if string.find(cmd, "run lotto") then
					lotto()
					append(color.lblue, "Running lotto()")
			end
			if cmd == "run" then append(color.gray, "Usage: /run [script function]"); append(color.gray, "Listed functions: updaterank, updatetags, spawn, paycheck"); append(color.gray, "...targethit, checktarget, summon, lotto"); return end
			return
		end
		-- USE ITEMS
		if cmd == "use" or cmd == "use " then append(color.gray, "Usage: /use [40oz/weed/coke/candybar/gum/cig]"); cmdisvalid = true end
		-- CANDYBAR
		if cmd == "use candybar" then
			cmdisvalid = true
			if inv.candybar.qnty > 0 then
				append(color.rp, player.name.." unwraps a candy bar and eats it.")
				inv.candybar.qnty = inv.candybar.qnty - 1
			if player.hp + 10 <= 100 then
				player.hp = player.hp + 10
				elseif player.hp + 10 >= 100 then append(color.gray, "You have reached maximum health.")
			end
			elseif inv.candybar.qnty <= 0 then append(color.gray, "You do not have a candy bar.")
			end -- end of if player has candybar
		end
		-- GUM
		if cmd == "use gum" then
			cmdisvalid = true
			local apgiven = false
			local hpgiven = false
			if inv.gum.qnty > 0 then
				append(color.rp, player.name.." unwraps a stick of gum and starts chewing.")
				inv.gum.qnty = inv.gum.qnty - 1
			if player.ap + 5 <= 10 then
				player.ap = player.ap + 5; player.maxap = player.ap
				apgiven = true
			elseif player.ap + 5 > 10 then append(color.gray,"Maximum armor from gum reached."); apgiven = false
			end
				if player.hp + 5 <= 100 then
					player.hp = player.hp + 5
					hpgiven = true
				elseif player.hp + 5 > 100 then append(color.gray, "You have reached maximum health."); hpgiven = false
				end
			if apgiven == true and hpgiven == true then append(color.green, "Your HP and AP have both been increased by 5!") end
			if apgiven == true and hpgiven == false then append(color.green, "Your AP has been increased by 5!") end
			if hpgiven == true and apgiven == false then append(color.green, "Your HP has been increased by 5!") end
		elseif inv.gum.qnty <= 0 then append(color.gray, "You do not have any gum.")
		end -- end of if player has gum
	end -- end of gum
		-- 40OZ
		if cmd == "use 40oz" then
			cmdisvalid = true
			if inv.fourty.qnty > 0 then
			append(color.rp, player.name.." opens 40oz of malt liquor and starts drinking.")
				if player.hp + 15 < 100 then
					player.hp = player.hp + 15
					append(color.green, "Your HP was increased by 15.")
				else
					player.hp = 100
					append(color.gray, "You are already at full HP.")
				end
				inv.fourty.qnty = inv.fourty.qnty - 1
				player.clothes.hand = txtrs.clothes.beer
				player.clothes.handX = player.x + 2
				player.clothes.handY = player.y + 2
			else append(color.gray, "You do not have a 40oz.")
			end
		end
		-- WEED
		if cmd == "use weed" then
			cmdisvalid = true
			if inv.weed.qnty > 0 then
				append(color.rp, player.name.." rolls up a joint and starts to smoke it.")
				inv.weed.qnty = inv.weed.qnty - 1
				player.hp = player.hp + 20
				if player.hp > 100 then player.hp = 100; append(color.green, "'Mama didn't raise no quitter!' You feel well-medicated."); append(color.gray, "You have maximum health."); return end
				if player.hp >= 25 and player.hp < 50 then player.hpcolor = color.yellow end
				if player.hp > 50 and player.hp < 90 then player.hpcolor = color.green end
				if player.hp >= 90 then player.hpcolor = color.green end
				player.clothes.hand = txtrs.clothes.joint
				player.clothes.handX = player.x - 2
				player.clothes.handY = player.y
				append(color.green, "Your HP was increased by 20.")
				if player.hp > player.maxhp then player.hp = player.maxhp end
			elseif inv.weed.qnty <= 0 then
				append(color.gray, "You do not have any weed.")
			return end
			end
		-- COKE
		if cmd == "use coke" then
			cmdisvalid = true
			if inv.coke.qnty > 0 then
				append(color.rp, player.name.." snorts a bump of cocaine.")
				inv.coke.qnty = inv.coke.qnty - 1
				append(color.green, "Your AP was increased by 15.")
				player.ap = player.ap + 15; player.maxap = player.ap
				if player.ap >= 30 then append(color.gray, "Maximum armor from cocaine reached."); player.ap = 30 end
				if player.ap > player.maxap then player.ap = player.maxap end
			elseif inv.coke.qnty <= 0 then
				append(color.gray, "You do not have any cocaine.")
			end
			return end
		-- CIG
		if cmd == "use cig" then
			cmdisvalid = true
			if inv.cigs.qnty > 0 then
				append(color.rp, "You spark up a cigarette and start to smoke it.")
				append(color.gray, "Use /snuffcig to extinguish it.")
				inv.cigs.qnty = inv.cigs.qnty - 1
				player.clothes.hand = txtrs.clothes.ciggy
				player.clothes.handX = player.x + 3
				player.clothes.handY = player.y
				if (inv.cigs.qnty) <= 0 then append(color.rp, "You throw away the empty pack afterwards.") end
			elseif inv.cigs.qnty <= 0 then
				append(color.gray, "You do not have any cigarettes.")
			end
		end
		-- SNUFF CIG
		if cmd == "snuffcig" then
			cmdisvalid = true
			if player.clothes.hand == txtrs.clothes.ciggy then player.clothes.hand = txtrs.clothes.none; append(color.rp, "You snuff the cigarette butt out.")
				else append(color.gray, "You are not smoking a cigarette.")
			end
		end
		-- EQUIP WEAPON
			if string.find(cmd, "equip") and cmd ~= "equip" then
				cmdisvalid = true
				local weaponslot = tonumber(string.match(cmd, "%d+"))
				local weapon = ""
				local domsg = false
				if weaponslot == 0 then weapon = player.weapons.slot0; player.weapons.weapontxtr = txtrs.clothes.none; player.weapons.selected = "fists"; crosshair(false) end
				if weaponslot == 1 and player.weapons.has1 == true then weapon = player.weapons.slot1; player.weapons.weapontxtr = txtrs.weapons.glockr; player.weapons.selected = "glock"; crosshair(true); domsg = true end
				if weaponslot == 2 and player.weapons.has2 == true then weapon = player.weapons.slot2; player.weapons.weapontxtr = txtrs.weapons.shortyr; player.weapons.selected = "shorty"; crosshair(true); domsg = true end
				if weaponslot == 3 and player.weapons.has3 == true then weapon = player.weapons.slot3; player.weapons.weapontxtr = txtrs.weapons.akr; player.weapons.selected = "ak"; crosshair(true); domsg = true end
				if weaponslot > 3 then append(color.gray, "Usage: /equip [weapon slot] (Try /weapons)") end
				if weaponslot ~= 0 and domsg == true then append(color.rp, player.name.." pulls out a "..weapon..".") end
				if weaponslot == 0 and domsg == true then append(color.rp, player.name.." puts their weapon away.") player.weapons.selected = "fists"; crosshair(false) end
				return
			elseif cmd == "equip" then append(color.gray, "Usage: /equip [weapon slot] (Try /weapons)")
			return
			end
			-- VIEW WEAPONS
		if cmd == "weapons" then
			cmdisvalid = true
			append(color.white, "You are currently armed with: ")
			append(color.lgreen, ("[Slot 1]: "..player.weapons.slot1.." [Slot 2]: "..player.weapons.slot2.." [Slot 3]: "..player.weapons.slot3))
			return
		end
		-- SET
		if cmd == "set" then
			cmdisvalid = true
			append(color.gray, "Usage: /set [data] [value]")
			append(color.gray, "[data]: skin, name, health, armor, weed, coke, faction, rank, cash")
			append(color.gray, "[CONT.] cigs, light, lvl")
			return
		end
			-- SET HOOD
			if string.find(cmd, "set hood") and cmd ~= "set hood" then
				local isrecognized = false
				if cmd == "set hood northwest" or cmd == "set hood nw" then city.hood = 1; txtrs.city.txtr = txtrs.city.northwest; isrecognized = true end
				if cmd == "set hood northmid" or cmd == "set hood nm" then city.hood = 2; txtrs.city.txtr = txtrs.city.northmid; isrecognized = true end
				if cmd == "set hood northeast" or cmd == "set hood ne" then city.hood = 3; txtrs.city.txtr = txtrs.city.northeast; isrecognized = true end
				if cmd == "set hood midwest" or cmd == "set hood mw" then city.hood = 4; txtrs.city.txtr = txtrs.city.midwest; isrecognized = true end
				if cmd == "set hood downtown" or cmd == "set hood dt" or cmd == "set hood mm" then city.hood = 5; txtrs.city.txtr = txtrs.city.downtown; isrecognized = true end
				if cmd == "set hood mideast" or cmd == "set hood me" then city.hood = 6; city.hood = 6; txtrs.city.txtr = txtrs.city.mideast; isrecognized = true end
				if cmd == "set hood southwest" or cmd == "set hood sw" then city.hood = 7; txtrs.city.txtr = txtrs.city.southwest; isrecognized = true end
				if cmd == "set hood southmid" or cmd == "set hood sm" then city.hood = 8; txtrs.city.txtr = txtrs.city.southmid; isrecognized = true end
				if cmd == "set hood parkwood" or cmd == "set hood pw" or cmd == "se" then city.hood = 9; txtrs.city.txtr = txtrs.city.southeast; isrecognized = true end
				if isrecognized == false then append(color.gray, "Unrecognized hood name. Use full name or XY format. (try /set hood)") end
				append(color.lgray, "Successfully set hood.")
				cmdisvalid = true
			elseif cmd == "set hood" or cmd == "set hood " then append(color.gray, "Usage: /set hood [in-script name] (ex. /set hood nw)"); append(color.gray, "XY (x = (N)orth/(M)id/(S)outh) (y = (W)est/(M)id/(E)ast)")
			end
			-- SET SKIN
			if string.find(cmd, "set skin") and cmd ~= "set skin" then
				cmdisvalid = true
				local skintoset = nil
				local output = string.sub(cmd, 10, 20)
					skintoset = lf.getInfo("skins/sprite/"..output..".png")
					if skintoset == nil then append(color.gray, "Skin '"..output.."' not found!"); return end
					append(color.lgray, ("Set player's skin to '"..output.."'."))
					anim.sprites.pskin = newAnimation(lg.newImage("skins/sprite/"..output.."f.png"), 40, 65, 1)
					anim.sprites.pskin2 = newAnimation(lg.newImage("skins/sprite/"..output.."b.png"), 40, 65, 1)
					anim.sprites.pskin3 = newAnimation(lg.newImage("skins/sprite/"..output..".png"), 40, 65, 8)
					player.skin = output
				elseif cmd == "set skin" then append(color.gray, "Usage: /set skin [file]")
				return
			end
			-- 	SET HEALTH / ARMOR
			if string.find(cmd, "set ap") and cmd ~= "set ap" then
				cmdisvalid = true
				local armortogive = tostring(string.match(cmd, "%d+"))
				local givearmor = true
				if tonumber(armortogive) > 100 then append(color.gray, "Cannot give more than 100 armor.") end
				if givearmor == true then
					player.ap = tonumber(armortogive)
					append(color.lgray, ("Set player's armor to "..armortogive..".")); n.ap_given = tonumber(armortogive)
					if player.ap > 50 and player.factionid == 1 then player.clothes.torso = txtrs.clothes.vestpd_f; player.clothes.torso_f = txtrs.clothes.vestpd_f; player.clothes.torso_b = txtrs.clothes.vestpd_b
						elseif player.ap > 50 then player.clothes.torso = txtrs.clothes.vestcivf; player.clothes.torso_f = txtrs.clothes.vestcivf; player.clothes.torso_b = txtrs.clothes.vestcivb
					end
					if player.ap <= 50 then player.clothes.torso = txtrs.clothes.none; player.clothes_torso_f = txtrs.clothes.none; player.clothes.torso_b = txtrs.clothes.none end
				end
			elseif cmd == "set ap" then append(color.gray, "Usage: /set ap [armor]")
				return
			end
			if string.find(cmd, "set hp") and cmd ~= "set hp" then
				cmdisvalid = true
				local healthtogive = tostring(string.match(cmd, "%d+"))
				local givehealth = true
				if  player.isdowned == true then
					append(color.gray, "Player is downed. Use /revive instead.")
					givehealth = false
				end
				if tonumber(healthtogive) > 100 then
				append(color.gray, "Cannot give more than 100 health.")
				givehealth = false
				end
				if givehealth == true then player.hp = healthtogive; append(color.lgray, ("Set player's health to "..healthtogive..".")); n.hp_given = tonumber(healthtogive) end
			elseif cmd == "set hp" then append(color.gray, "Usage: /set hp [health]")
				return
			end
			-- SET CASH
			if string.find(cmd, "set cash") and cmd ~= "set cash" then
				cmdisvalid = true
				local cashtogive = string.sub(cmd, 10, 16)
				local givecash = true
				if tonumber(cashtogive) > 999999 then
					append(color.gray, "Cannot give more than $999,000.")
					givecash = false
				end
				if tonumber(cashtogive) <= -1000000 then
					append(color.gray, "Cannot give less than -$999,999.")
					givecash = false
				end
				if givecash == true then player.cash = tonumber(cashtogive); append(color.lgray, ("Set player's cash to "..tonumber(cashtogive)..".")) end
				elseif cmd == "set cash" then append(color.gray, "Usage: /set cash [amount] (max: 999,000)")
				return
			end
			-- SET X
			if string.find(cmd, "set x") and cmd ~= "set x" and cmd ~= "set x " and not string.find(cmd, "xp") then
				cmdisvalid = true
				local xpostoset = tonumber(string.sub(cmd, 7, 11))
				world.x = xpostoset
				append(color.lgray, "Set X to "..xpostoset..".")
				elseif cmd == "set x" or cmd == "set x " then append(color.gray, "Usage: /set x [position]")
				return
			end
			-- SET Y
			if string.find(cmd, "set y") and cmd ~= "set y" and cmd ~= "set y " then
				cmdisvalid = true
				local ypostoset = tonumber(string.sub(cmd, 7, 11))
				world.y = ypostoset
				append(color.lgray, "Set Y to "..ypostoset..".")
				elseif cmd == "set y" or cmd == "set y " then append(color.gray, "Usage: /set y [position]")
				return
			end
			-- SET NAME
			if string.find(cmd, "set name") and cmd ~= "set name" then
				cmdisvalid = true
				local nametogive = string.sub(cmd, 10, 30)
				local prevname = player.name
				nametogive = string.gsub(" "..nametogive, "%W%l", string.upper):sub(2)
				player.name = nametogive
				append(color.lgray, "Changed player's name from '"..prevname.."' to '"..nametogive.."'.")
			elseif cmd == "set name" then append(color.gray, ("Usage: /set name [character name] (limit of 30 characters)"))
				return
			end
			-- SET RACE
			if string.find(cmd, "set race") and cmd ~= "set race" and cmd ~= "set race " then
				cmdisvalid = true
				local racetoset = string.sub(cmd, 10, 13)
				local setrace = true
				if racetoset ~= "wma" or "wfa" or "bma" or "bfa" or "hma" or "hfa" then
					append(color.gray, "Race must be in RACE-SEX format (ex. WMA - white male)")
					setrace = false
				end
				player.race = racetoset
				append(color.lgray, "Changed player's race-sex to "..string.upper(racetoset)..".")
			elseif cmd == "set race" or cmd == "set race " then append(color.gray, ("Usage: /set race [XZZ] (X: race - w/b/h ZZ: sex - ma/fa)"))
				return
			end
			-- SET WEED
			if string.find(cmd, "set weed") and cmd ~= "set weed" then
				cmdisvalid = true
				local weedtogive = tonumber(string.match(cmd, "%d+"))
				inv.weed.qnty = weedtogive
				append(color.lgray, ("Set player's weed quantity to "..weedtogive.."."))
				return
			elseif cmd == "set weed" then append(color.gray, "Usage: /set [item] [qnty]")
				return
			end
			-- SET COKE
			if string.find(cmd, "set coke") and cmd ~= "set coke" then
				cmdisvalid = true
				local coketogive = tonumber(string.match(cmd, "%d+"))
				inv.coke.qnty = coketogive
				append(color.lgray, ("Set player's coke quantity to "..coketogive.."."))
				return
			elseif cmd == "set coke" then append(color.gray, "Usage: /set coke [qnty]")
				return
			end
			-- SET CIGS
			if string.find(cmd, "set cigs") and cmd ~= "set cigs" then
				cmdisvalid = true
				local cigstogive = tonumber(string.match(cmd, "%d+"))
				inv.cigs.qnty = cigstogive
				append(color.lgray, ("Set player's cigs quantity to "..cigstogive.."."))
				return
			elseif cmd == "set cigs" then append(color.gray, "Usage: /set cigs [qnty]")
				return
			end
			-- SET LVL
			if string.find(cmd, "set lvl") and cmd ~= "set lvl" then
				cmdisvalid = true
				local leveltoset = tonumber(string.match(cmd, "%d+"))
				local throwerror = false
				if leveltoset > 99 then throwerror = true; append(color.gray, "Level cannot exceed 99.") end
				if leveltoset < 1 then throwerror = true; append(color.gray, "Level must be at least 1.") end
				if throwerror == false then player.lvl = leveltoset; append(color.lgray, ("Set player's level to "..leveltoset..".")) return end
			elseif cmd == "set lvl" then append(color.gray, "Usage: /set lvl [level]")
			end
			-- SET FACTION
			if string.find(cmd, "set faction") and cmd ~= "set faction" then
				cmdisvalid = true
				local valuetoset = tonumber(string.match(cmd, "%d+"))
				local newfaction = ""
				local throwerror = false
				local factioncolor = {1, 1, 1}
				if valuetoset == 0 then newfaction = "Civilian"; factioncolor = color.lgray end
				if valuetoset == 1 then newfaction = "Parkwood City PD"; factioncolor = color.blue  end
				if valuetoset == 2 then newfaction = "Parkwood City FD"; factioncolor = color.dred end
				if valuetoset == 3 then newfaction = "Parkwood PERPz"; factioncolor = color.purple end
				if valuetoset == 4 then newfaction = "Uptown Project Killas"; factioncolor = color.green end
				if valuetoset == 5 then newfaction = "Eastside Leyendas"; factioncolor = color.lblue end
				if valuetoset == 6 then newfaction = "Sprinter Logistics"; factioncolor = color.yellow end
				if valuetoset <= 6 then
					player.factionid = valuetoset
					player.faction = newfaction
					player.factionrankid = 1
					updaterank(1)
					append(factioncolor, ("Set player's faction to "..newfaction.." (ID "..valuetoset..") as rank 1/5."))
				else append(color.gray, "Faction ID cannot exceed 7.") return end
				return
				elseif cmd == "set faction" then append(color.gray, "Usage: /set faction [id]")
			return
			end
			-- KILL PLAYER
			if cmd == "kill" then
				player.hp = 0
				player.downed = true
				player.canmove = false
				summon("emt")
				append(color.gray, "Killed player.")
				cmdisvalid = true
			end
			-- SET RANK
			if string.find(cmd, "set rank") and cmd ~= "set rank" then
				cmdisvalid = true
				local valuetoset = tonumber(string.match(cmd, "%d+"))
				local newrank = valuetoset
				local throwerror = false
				if newrank > 5 then throwerror = true end
				if newrank <= 5 then append(color.lgray, ("Set player's faction rank to "..newrank.."/5 in "..player.faction..".")) end
				updaterank(newrank)
				return
				elseif cmd == "set rank" or throwerror == true then append(color.gray, "Usage: /set rank [rank id] (max rank: 5)")
			end
			-- SET LIGHTING
			if string.find(cmd, "set light") and cmd ~= "set light" then
				cmdisvalid = true
				local lighttoset = string.match(cmd, "%d+")
				local throwerror = false
				if tonumber(lighttoset) < 0 then append(color.gray, "Cannot set light less than 0."); throwerror = true end
				if tonumber(lighttoset) > 255 then append(color.gray, "Cannot set light greater than 255."); throwerror = true end
				if throwerror == false then
					graphics.lightr = lighttoset; graphics.lightg = lighttoset; graphics.lightb = lighttoset 
					append(color.lgray, ("Lighting set to ("..graphics.lightr..", "..graphics.lightg..", "..graphics.lightb..")"))
				end
			elseif cmd == "set light" then append(color.gray, "Usage: /set light [amount] (max: 255)"); cmdisvalid = true throwerror = true
			end
			-- SET AMMO
			if string.find(cmd, "set ammo") and cmd ~= "set ammo" and cmd ~= "set ammo " then
				cmdisvalid = true
				local ammotoset = tonumber(string.match(cmd, "%d+"))
				if player.weapons.selected == "glock" then player.weapons.ammo1 = ammotoset end
				if player.weapons.selected == "shorty" then player.weapons.ammo2 = ammotoset end
				if player.weapons.selected == "ak" then player.weapons.ammo3 = ammotoset end
				if player.weapons.selected == "fists" then append(color.gray, "You must be holding a firearm to set its ammo."); return end
				append(color.lgray, "Set player's ammo for current weapon to "..ammotoset)
				elseif cmd == "set ammo" or cmd == "set ammo " then append(color.gray, "Usage: /set ammo [amount]")
			end
		-- GET Version
		if cmd == "version" then
				append(color.lblue, "StreetzRPG "..n.version)
				cmdisvalid = true
			end
		-- HURT PLAYER
		if string.find(cmd, "hurt") and cmd ~= "hurt" then
				cmdisvalid = true
				local dmgtogive = tonumber(string.match(cmd, "%d+"))
				playerhit(dmgtogive)
				append(color.dred, "Hurt player with "..dmgtogive.." points of damage.")
				return
				elseif cmd == "hurt" then playerhit(1) append(color.dred, "Hurt player with 1 point of damage.")
				return
			end
		-- PHONE CALL
		if string.find(cmd, "call") and cmd ~= "call" then
				cmdisvalid = true
				local calling = tonumber(string.match(cmd, "%d+"))
				if calling == 911 then
					if (player.isdowned == true or player.hp <= 25) and player.incombat == false then 
						append(color.white, "(Phone) EMS Dispatch: Stay calm, I'm sending help.")
						append(color.lgray, "You hangup the phone.")
						ped.emt.txtrf = skin; ped.emt.txtrb = txtrs.skins.emt1b; ped.emt.textr = ped.emt.txtrf
						summon("emt")
					end
					if player.isdowned == false or player.hp >= 25 then
						append(color.white, "(Phone) EMS Dispatch: We're tied up with higher-priority calls.")
						append(color.white, "(Phone) EMS Dispatch: Visit the hospital if you need treatment.")
						append(color.lgray, "You hangup the phone.")
					end
					if (player.isdowned == true or player.hp <= 25) and player.incombat == true then
						append(color.white, "(Phone - EMS Dispatcher): I can't send a unit quite yet.")
						append(color.white, "(Phone - EMS Dispatcher): There's an active threat nearby.")
						append(color.lgray, "You hangup the phone.")
					end
				end
				if calling == 885 then
					append(color.white, "(Phone) Dealer: Lookin' to buy, are ya? I'll met ya in five.")	
					append(color.lgray, "You hangup the phone.")
				end
				return
				elseif cmd == "call" then append(color.gray, "Usage: /call [number]")
				return
			end
		-- STATS
		if cmd == "stats" then
			cmdisvalid = true
			local factioncolor = {1, 1, 1}
			if player.factionid == 0 then newfaction = "Civilian"; factioncolor = color.lgray end
			if player.factionid == 1 then newfaction = "Parkwood City PD"; factioncolor = color.blue  end
			if player.factionid == 2 then newfaction = "Parkwood City FD"; factioncolor = color.dred end
			if player.factionid == 3 then newfaction = "Parkwood PERPz"; factioncolor = color.purple end
			if player.factionid == 4 then newfaction = "Uptown Project Killas"; factioncolor = color.green end
			if player.factionid == 5 then newfaction = "Eastside Leyendas"; factioncolor = color.lblue end
			if player.factionid == 6 then newfaction = "Sprinter Logistics"; factioncolor = color.yellow end
			append(color.lgreen, (player.name..", ("..string.upper(player.race)..") Level: "..player.lvl.." ("..player.xp.."XP/"..player.maxxp.."), K: "..player.kills..", D: "..player.deaths.." (KDR: "..(math.floor(player.kills / player.deaths))..")"))
			append(factioncolor, ("Faction: "..player.faction.." (ID "..player.factionid..") Rank: "..player.factionrank.." ("..player.factionrankid.."/5)"))
		return end
		-- TRAVEL
		if cmd == "travel" then
			cmdisvalid = true
			n.marker.pos_x = n.marker.tpos_x; n.marker.pos_y = n.marker.tpos_y
			if player.wanted == false then holsterall() end
			if player.inint == true then append(color.gray, "You are in an interior.") return end
			if data.movingn == false and data.movinge == false and data.movings == false and data.movingw == false and player.inint == false then
				append(color.gray, "You are not near the edge of the neighborhood.")
				return
			end
			-- evasion
			if player.wanted == true then
				local evade = love.math.random(1,4)
				if evade == 4 then
					append(color.blue, "You have evaded the police!")
					player.wanted = false
				end
				if evade ~= 4 then append(color.red, "The police continue to pursue you.") end
			end
			if city.hood == 1 then
				if data.movinge == true then
					txtrs.city.txtr = txtrs.city.northmid
					world.x = 250; world.y = -500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 2
					append(color.lgray, "You travel east into Northmid.")
					pedlist.placegang(2)
					data.movinge = false
					marker_check()
					return
				end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.midwest
					world.x = -1225; world.y = 250
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 4
					append(color.lgray, "You travel south into West-Central.")
					pedlist.placegang(3)
					data.movings = false
					marker_check()
					return
				end
				if data.movingn == true or data.movingw == true then append(color.gray, "You cannot go that way.") end
			end
			if city.hood == 2 then
				if data.movinge == true then
					txtrs.city.txtr = txtrs.city.northeast
					world.x = 250; world.y = -500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 3
					append(color.lgray, "You travel east into Uptown.")
					pedlist.placegang(2)
					data.movinge = false
					marker_check()
					return
					end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.downtown
					world.x = -1125; world.y = 250
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 5
					append(color.lgray, "You travel south into Downtown.")
					pedlist.placeciv()
					data.movings = false
					marker_check()
					return
				end
				if data.movingn == true then append(color.gray, "You cannot go that way.") end
			end
			if city.hood == 3 then
				if data.movingw == true then
					txtrs.city.txtr = txtrs.city.northmid
					world.x = -1500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 2
					append(color.lgray, "You travel west into Northmid.")
					pedlist.placegang(2)
					data.movingw = false
					marker_check()
					return
				end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.mideast
					world.x = -1500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 6
					append(color.lgray, "You travel south into East-Central.")
					pedlist.placefd()
					data.movings = false
					marker_check()
					return
				end
			if data.movingn == true or data.movinge == true then append(color.gray, "You cannot go that way.") end
			end
			if city.hood == 2 then
				if data.movingw == true then
					txtrs.city.txtr = txtrs.city.northwest
					world.x = -1500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 1
					append(color.lgray, "You travel west into Coastal Bay.")
					pedlist.placegang(2)
					data.movingw = false
					marker_check()
					return
				end
			if data.movingn == true then append(color.gray, "You cannot go that way.") end
			end			
			if city.hood == 9 then
				if data.movingw == true then
					txtrs.city.txtr = txtrs.city.southmid
					world.x = -1500
					if player.isdragging == true then cscript.runcmd("/get "..player.dragging) end
					placenpcs(4)
					updatetags()
					city.hood = 8
					append(color.lgray, "You travel west into Southmid.")
					pedlist.placegang(1)
					data.movingw = false
					marker_check()
					return
				end
				if data.movingn == true then
					txtrs.city.txtr = txtrs.city.mideast
					world.x = -10
					world.y = -1450
					placenpcs(4)
					updatetags()
					city.hood = 6
					append(color.lgray, "You travel north into East-Central.")
					pedlist.placefd()
					data.movingn = false
					marker_check()
					return
				end
			end
		if city.hood == 8 then
			if data.movinge == true then
					txtrs.city.txtr = txtrs.city.southeast
					world.x = 200
					placenpcs(4)
					updatetags()
					city.hood = 9
					append(color.lgray, "You travel east into Parkwood.")
					pedlist.placegang(1)
					data.movinge = false
					marker_check()
					return
				end
				if data.movingw == true then
					txtrs.city.txtr = txtrs.city.southwest
					world.x = -1500
					world.y = -600
					placenpcs(4)
					updatetags()
					data.movingw = false
					-- TODO: audio of machinery
					city.hood = 7
					append(color.lgray, "You travel west into The Dockyards.")
					pedlist.placegang(3)
					data.movingw = false
					marker_check()
					return
				end
				if data.movingn == true then
					txtrs.city.txtr = txtrs.city.downtown
					placenpcs(4)
					world.x = -1125
					world.y = -1450
					placenpcs(4)
					updatetags()
					city.hood = 5
					append(color.lgray, "You travel north into Downtown.")
					pedlist.placeciv()
					data.movingn = false
					marker_check()
					return
				end
			end
		if city.hood == 7 then
			if data.movinge == true then
					txtrs.city.txtr = txtrs.city.southmid
					world.x = 200
					placenpcs(4)
					updatetags()
					city.hood = 8
					append(color.lgray, "You travel east into Southmid.")
					pedlist.placegang(1)
					data.movinge = false
					marker_check()
					return
				end
				if data.movingn == true then
					txtrs.city.txtr = txtrs.city.midwest
					world.x = -1200; world.y = -1450
					placenpcs(4)
					updatetags()
					city.hood = 4
					append(color.lgray, "You travel north into West-Central.")
					pedlist.placegang(3)
					data.movinge = false
					marker_check()
					return
				end
			end
		if city.hood == 4 then
			if data.movinge == true then
					txtrs.city.txtr = txtrs.city.downtown
					world.x = 200
					world.y = -600
					placenpcs(4)
					updatetags()
					city.hood = 5
					append(color.lgray, "You travel east into Downtown.")
					pedlist.placeciv()
					data.movinge = false
					marker_check()
					return
				end
				if data.movingn == true then
				txtrs.city.txtr = txtrs.city.northwest
					world.x = -1225; world.y = -1450
					placenpcs(4)
					updatetags()
					city.hood = 1
					append(color.lgray, "You travel north into Coastal Bay.")
					pedlist.placegang(2)
					data.movingn = false
					marker_check()
					return
				end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.southwest
					world.x = -1200; world.y = 250
					placenpcs(4)
					updatetags()
					city.hood = 7
					append(color.lgray, "You travel south into The Dockyards.")
					pedlist.placegang(3)
					data.movinge = false
					marker_check()
					return
				end
			end
		if city.hood == 6 then
			if data.movingw == true then
					txtrs.city.txtr = txtrs.city.downtown
					world.x = -1450
					world.y = -600
					placenpcs(4)
					updatetags()
					city.hood = 5
					append(color.lgray, "You travel west into Downtown.")
					pedlist.placeciv()
					data.movingw = false
					marker_check()
					return
				end
				if data.movingn == true then
				txtrs.city.txtr = txtrs.city.northeast
					world.x = -5
					world.y = 1450
					placenpcs(4)
					updatetags()
					city.hood = 3
					append(color.lgray, "You travel north into Northeast.")
					pedlist.placegang(2)
					data.movingn = false
					marker_check()
					return
				end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.southeast
					world.x = -95
					world.y = 250
					placenpcs(4)
					updatetags()
					city.hood = 9
					append(color.lgray, "You travel south into Parkwood.")
					pedlist.placegang(1)
					data.movings = false
					marker_check()
					return
				end
			end
		if city.hood == 5 then
			if data.movingw == true then
					txtrs.city.txtr = txtrs.city.midwest
					world.x = -1450
					world.y = -600
					placenpcs(4)
					updatetags()
					city.hood = 4
					append(color.lgray, "You travel west into West-Central.")
					pedlist.placegang(3)
					data.movingw = false
					marker_check()
					return
				end
				if data.movinge == true then
					txtrs.city.txtr = txtrs.city.mideast
					world.x = 250
					world.y = -600
					placenpcs(4)
					updatetags()
					pedlist.placefd()
					city.hood = 6
					append(color.lgray, "You travel east into East-Central.")
					pedlist.placefd()
					data.movinge = false
					marker_check()
					return
				end
				if data.movingn == true then
				txtrs.city.txtr = txtrs.city.northmid
					world.x = -1225; world.y = -1450
					placenpcs(4)
					updatetags()
					city.hood = 2
					append(color.lgray, "You travel north into Northmid.")
					pedlist.placegang(2)
					data.movingn = false
					marker_check()
					return
				end
				if data.movings == true then
					txtrs.city.txtr = txtrs.city.southmid
					world.x = -1125
					world.y = 250
					placenpcs(4)
					updatetags()
					city.hood = 8
					append(color.lgray, "You travel south into Southmid.")
					pedlist.placegang(1)
					data.movings = false
					marker_check()
					return
				end
			end
			marker_check()
			gethoodid()
		end -- end of /travel
		-- DEVMODE
		if cmd == "devmode" then append(color.gray, "Usage: /devmode [on/off] (or use F1)"); cmdisvalid = true end
		-- DEVMODE ON
		if cmd == "devmode on" then
			n.hp_prior = player.hp
			n.ap_prior = player.ap
			print("[DEVMODE] Player had "..n.hp_prior.." HP, and "..n.ap_prior.." AP prior to ENTERING devmode.")
			n.devmode = true
			n.devtags = true
			append(color.lblue, "Developer mode and tags enabled!")
			player.maxhp = 999
			player.maxap = 999
			player.hp = player.maxhp
			player.ap = player.maxap
			player.speed = player.regularspeed
			player.speed = 10
			cmdisvalid = true
			return
		end
		if cmd == "devmode off" then
			if (n.hp_prior ~= n.hp_given and n.hp_given > 0) then player.hp = n.hp_given else player.hp = n.hp_prior end -- if hp/ap was given while in devmode, keep that amount
			if (n.ap_prior ~= n.ap_given and n.ap_given >0) then player.ap = n.ap_given else player.ap = n.ap_prior end
			print("[DEVMODE] Player is EXITING devmode with "..player.hp.."HP, and "..player.ap.."AP.")
			n.devmode = false
			n.devtags = false
			append(color.red, "Developer mode and tags disabled.")
			player.maxhp = 100
			player.maxap = player.ap
			player.maxap = player.ap
			player.speed = player.regularspeed
			player.fastspeed = player.regularspeed * 2
			cmdisvalid = true
			return
			end -- END OF DISABLE
		-- DEVTAGS
		if cmd == "devtags" then
			if n.devtags == true then
				n.devtags = false
				if n.devmode == false then append(color.dred, "Developer tags disabled.") end
				if n.devmode == true then append(color.dred, "Developer tags disabled, disable devmode as well to hide them.") end
				return
			end 
			if n.devtags == false then
				n.devtags = true
				append(color.lblue, "Developer tags enabled!")
				return
			end
			cmdisvalid = true
		end
		-- TOGGLE INVENTORY
		if cmd == "inv on" then n.inv = true; print("[cscript] inventory opened"); cmdisvalid = true end
		if cmd == "inv off" then n.inv = false; print("[cscript] inventory closed"); cmdisvalid = true end
		-- CREDITS
		if cmd == "credits" then
			append(color.green, "- Project StreetzRPG -")
			append(color.lgray, ("Version: "..n.version.." (SEP 2018 to JULY 2019)"))
			append(color.white, "Created and developed by Bryan Mader")
			append(color.lblue, "Scripters: Rvcboy")
			append(color.green, "Artists: Motorhead")
			append(color.orange, "Testers: JinChill, Semy, Dann, ZkEdj, codac, decabyte, Dom., Baha, Sunflivia")
			append(color.lgray, "Special thanks: LOVE2D, SA-MP, XGen, Rockstar, TheTruth, Blazerguy97")
			cmdisvalid = true
		end
		-- REVIVE
		if cmd == "revive" then
			cmdisvalid = true
			player.hp = (player.maxhp / 4)
			player.isdown = false
			player.canmove = true
			player.hpcolor = color.lgreen
			player.clothes.gore = txtrs.clothes.none
			append(color.lgray, "Player revived and is no longer downed.")
		end
		-- CLEARCHAT
		if cmd == "clear" then
			cmdisvalid = true
			if n.devmode == true then
				msg.line0 = "[0]"; msg.line1 = "[1]"; msg.line2 = "[2]"; msg.line3 = "[3]"; msg.line4 = "[4]"; msg.line5 = "[5]"; msg.line6 = "[6]"; msg.line7 = "[7]"; msg.line8 = "[8]"; msg.line9 = "[9]"
			end
			if n.devmode == false then
				msg.line0 = ""; msg.line1 = ""; msg.line2 = ""; msg.line3 = ""; msg.line4 = ""; msg.line5 = ""; msg.line6 = ""; msg.line7 = ""; msg.line8 = ""; msg.line9 = ""
			end
			msg.color0 = color.white; msg.color1 = color.white; msg.color2 = color.white; msg.color3 = color.white; msg.color4 = color.white; msg.color5 = color.white; msg.color6 = color.white; msg.color7 = color.white; msg.color8 = color.white; msg.color9 = color.white
		end
		-- SUMMON COP
		if string.find(cmd, "summon cop") and cmd ~= "summon" then
			cmdisvalid = true
			summon("cop")
		elseif cmd == "summon" then append(color.gray, "Usage: /summon [npc type]")
			return
		end
		-- DAY/NIGHT
		if string.find(cmd, "day") then
			cmdisvalid = true
			txtrs.sky = txtrs.sky1
			append(color.lgray, "Set time to daylight.")
			audio.night:setLooping(false)
			audio.night:stop()
			graphics.lightr = 255; graphics.lightg = 255; graphics.lightb = 255
		end
		if string.find(cmd, "night") then
			cmdisvalid = true
			txtrs.sky = txtrs.sky2
			append(color.lgray, "Set time to night.")
			audio.night:setLooping(true)
			audio.night:play()
			graphics.dayornight = "night"
			graphics.timeofday = 0
			graphics.lightr = 125; graphics.lightg = 125; graphics.lightb = 125
		end
		-- INVENTORY
		if cmd == "inv" then
			cmdisvalid = true
			append(color.lgreen, ("Inventory of "..player.name))
				append(color.white, ("Cash: $"..player.cash..", Weed: "..inv.weed.qnty..", Coke: "..inv.coke.qnty..", Cigarettes: "..inv.cigs.qnty..", 40oz: "..inv.fourty.qnty..", Gum: "..inv.gum.qnty))
				append(color.white, "Candybars: "..inv.candybar.qnty)
		end
		-- MUTE AUDIO
		if cmd == "mute" then
			audio.mastervolume = 0
			audio.smenu:setVolume(audio.mastervolume)
			audio.walk:setVolume(audio.mastervolume)
			audio.run:setVolume(audio.mastervolume)
			audio.chime:setVolume(audio.mastervolume)
			append(color.red, "Muted all audio.")
		end
		-- QUIT GAME
		if cmd == "q" or cmd == "quit" then cmdisvalid = true; love.event.quit() end
		-- TARGET NPC (GUNPLAY)
		if string.find(cmd, "target") and cmd ~= "target" and cmd ~= "target " then
			cmdisvalid = true
			local npctotarget = tonumber(string.match(cmd, "%d+"))
			getpath(npctotarget)
			append(color.lblue, "Targeted ID "..npctotarget..".")
			n.hasshown = false
			n.talkingto = "ped"..npctotarget
			elseif cmd == "target"or cmd == "target " then append(color.gray, "Usage: /target [ID]")
			return
		end
		-- SAVE GAME
		if string.find(cmd, "save") and cmd ~= "save" and cmd ~= "save " then
			cmdisvalid = true
			local saveslot = tonumber(string.match(cmd, "%d+"))
			local savedate = os.date ("%a, %b %y %H:%M")
		love.filesystem.write("sav"..saveslot..".lua", "player.house = "..tostring(player.house).."\nplayer.skin = '"..player.skin.."'\nplayer.cash = "..player.cash.."\nplayer.hp = "..player.hp.."\nplayer.ap = "..player.ap.."\nplayer.age = "..player.age.."\nplayer.kills = "..player.kills.."\nplayer.deaths = "..player.deaths.."\nplayer.lvl = "..player.lvl.."\nplayer.xp = "..player.xp.."\nplayer.maxxp = "..player.maxxp.."\nplayer.faction = '"..player.faction.."'".."\nplayer.factionid = "..player.factionid.."\nplayer.factionrank = '"..player.factionrank.."'\nplayer.factionrankid = "..player.factionrankid.."\nplayer.name = '"..player.name.."'".."\nplayer.race = '"..player.race.."'\nworld.x = "..world.x.."\nworld.y = "..world.y.."\ncity.hood = "..city.hood.."\nplayer.weapons.has1 = "..tostring(player.weapons.has1).."\nplayer.weapons.has2 = "..tostring(player.weapons.has2).."\nplayer.weapons.has3 = "..tostring(player.weapons.has3).."\nplayer.weapons.ammo1 = "..player.weapons.ammo1.."\nplayer.weapons.ammo2 = "..player.weapons.ammo2.."\nplayer.weapons.ammo3 = "..player.weapons.ammo3.."\ninv.fourty.qnty = "..inv.fourty.qnty.."\ninv.gum.qnty = "..inv.gum.qnty.."\ninv.candybar.qnty = "..inv.candybar.qnty.."\ninv.cigs.qnty = "..inv.cigs.qnty.."\ninv.weed.qnty = "..inv.weed.qnty.."\ninv.coke.qnty = "..inv.coke.qnty.."\ninv.frod.has = "..tostring(inv.frod.has).."\ninv.frod.hp = "..inv.frod.hp.."\ninv.bait.qnty = "..inv.bait.qnty.."\ninv.fbucket.slot1_weight = "..inv.fbucket.slot1_weight.."\ninv.fbucket.slot1_breed = '"..inv.fbucket.slot1_breed.."'\ninv.fbucket.slot1_worth = "..inv.fbucket.slot1_worth.."\ninv.fbucket.slot2_weight = "..inv.fbucket.slot2_weight.."\ninv.fbucket.slot2_breed ='"..inv.fbucket.slot2_breed.."'\ninv.fbucket.slot2_worth = "..inv.fbucket.slot2_worth.."\ninv.fbucket.slot3_weight = "..inv.fbucket.slot3_weight.."\ninv.fbucket.slot3_breed = '"..inv.fbucket.slot3_breed.."'\ninv.fbucket.slot3_worth = "..inv.fbucket.slot3_worth.."\ninv.fbucket.slot4_breed = '"..inv.fbucket.slot4_breed.."'\ninv.fbucket.slot4_worth = "..inv.fbucket.slot4_worth.."\ninv.fbucket.slot4_weight = "..inv.fbucket.slot4_weight.."\ninv.fbucket.slot5_breed = '"..inv.fbucket.slot5_breed.."'\ninv.fbucket.slot5_worth = "..inv.fbucket.slot5_worth.."\ninv.fbucket.slot5_weight = "..inv.fbucket.slot5_weight.."\ndata.day = "..data.day.."\ndata.lotto = "..data.lotto.."\nn.lastsaved = '"..savedate.."'")
			append(color.lgreen, "Saved "..player.name.." under save file "..saveslot.."!")
		elseif cmd == "save" or cmd == "save " then append(color.gray, "Usage: /save [character slot 1-3]")
		end
		-- LOAD GAME
		if string.find(cmd, "load") and cmd ~= "load" and cmd ~= "load " and not string.find(cmd, "reload") then
			cmdisvalid = true
			local loadslot = tonumber(string.match(cmd, "%d+"))
			loadgame = love.filesystem.load("sav"..loadslot..".lua")
			loadgame()
			print("[LOAD GAME] Name: "..player.name..", Skin: "..player.skin..", Slot: "..loadslot.."")
			if city.hood == 9 then txtrs.city.txtr = txtrs.city.southeast; city.hood = 9 end
			if city.hood == 8 then txtrs.city.txtr = txtrs.city.southmid; city.hood = 8 end
			if city.hood == 7 then txtrs.city.txtr = txtrs.city.southwest; city.hood = 7 end
			if city.hood == 6 then txtrs.city.txtr = txtrs.city.midwest; city.hood = 6 end
			if city.hood == 5 then txtrs.city.txtr = txtrs.city.mideast; city.hood = 4 end
			if city.hood == 4 then txtrs.city.txtr = txtrs.city.downtown; city.hood = 5 end
			if city.hood == 3 then txtrs.city.txtr = txtrs.city.northmidend end
			if city.hood == 2 then txtrs.city.txtr = txtrs.city.northeast end
			gethoodid()
			append(color.lgreen, "Loaded save file "..loadslot.." ("..player.name.."!)")
			anim.sprites.pskin = newAnimation(lg.newImage("skins/sprite/"..player.skin.."f.png"), 40, 65, 1)
			anim.sprites.pskin2 = newAnimation(lg.newImage("skins/sprite/"..player.skin.."b.png"), 40, 65, 1)
			anim.sprites.pskin3 = newAnimation(lg.newImage("skins/sprite/"..player.skin..".png"), 40, 65, 1)
			loadspawn()
			return
		elseif cmd == "load" or cmd == "load " then append(color.gray, "Usage: /load [character slot 1-3]"); cmdisvalid = true return
		end
		-- EVENT TEST
		if cmd == "etesty" then cmdisvalid = true event.new(2, nil, love.math.random(1,2), love.math.random(2,4)) end
		if cmd == "etestx" then cmdisvalid = true event.new(2, nil, love.math.random(3,4), love.math.random(2,4)) end
		-- PD DRAG
		if string.find(cmd, "drag") and cmd ~= "drag" and cmd ~= "drag " and cmd ~= "stopdrag"and player.factionid == 1 then
			cmdisvalid = true
			local npctodrag = tonumber(string.match(cmd, "%d+"))
			local dodrag = false
			getpath(npctodrag)
			if n.npcpath.incuffs == false then append(color.gray, "You cannot drag "..n.npcpath.name.." because they are not in cuffs."); dodrag = false; return end
			if n.npcpath.incuffs == true then dodrag = true end
			if dodrag == true then
				player.dragging = true
				player.dragging = npctodrag
				player.dragx = n.npcpath.x
				player.dragy = n.npcpath.y
				append(color.rp, "You grab "..n.npcpath.name.." and drag them along.")
			end
			if (cmd == "drag" or cmd == "drag ") and cmd ~= "stopdrag" and player.factionid == 1 then append(color.gray, "Usage: /drag [ID]"); cmdisvalid = true end
		end
		if (string.find(cmd, "drag") or string.find(cmd, "arrest") or string.find(cmd, "cuff")) and player.factionid ~= 1 then
			append(color.gray, "You are not a police officer.")
			cmdisvalid = true
		end
		-- PD STOP DRAG
		if cmd == "stopdrag" and player.factionid == 1 and n.npcpath.incuffs == true then
			cmdisvalid = true
			if player.factionid == 1 and player.dragx == nil then append(color.gray, "You are not dragging anyone.") end
			player.dragx = nil
			player.dragy = nil
			append(color.rp, "You let go of your grip on "..n.npcpath.name..".")
			updatetags()
		end
		-- PD UNCUFF
		if string.find(cmd, "uncuff") and cmd ~= "uncuff" and cmd ~= "uncuff " and player.factionid == 1 then
			cmdisvalid = true
			local idtouncuff = tonumber(string.match(cmd, "%d+"))
			getpath(idtouncuff)
			if n.npcpath.incuffs == false then append(color.gray, n.npcpath.name.." is not in cuffs.") end
			if n.npcpath.incuffs == true then
				append(color.rp, player.factionrank.." "..player.name.." uncuffs "..n.npcpath.name..".")
				n.npcpath.clothes = txtrs.clothes.none
				n.npcpath.incuffs = false
			end
		elseif cmd == "uncuff" or cmd == "uncuff " and player.factionid == 1 then append(color.gray, "Usage: /uncuff [ID]")
		end
		-- PD JAIL
		if string.find(cmd, "jail") and cmd ~= "jail" and cmd ~= "jail " and player.factionid == 1 then
			cmdisvalid = true
			local npctojail = tonumber(string.match(cmd, "%d+"))
			if city.int ~= "pd" then append(color.gray, "You must be at the jail in the PPD HQ."); return end
			getpath(npctojail)
			append(color.blue, "You have jailed "..n.npcpath.name..".")
			n.npcpath.x = -999
			xp(love.math.random(1,3))
		elseif cmd == "jail" or cmd == "jail " then append(color.gray, "Useage: /jail [id]")
		end
		-- PD ARREST
		if string.find(cmd, "arrest") and cmd ~= "arrest" and cmd ~= "arrest " and player.factionid == 1 then
			cmdisvalid = true
			local npctoarrest = tonumber(string.match(cmd, "%d+"))
			local makearrest = false
			local attemptnpc = love.math.random(1,3) --(1) attempts to flee but fails (2) attempts to flee and succeeds (3) complies
			getpath(npctoarrest)
			if attemptnpc == 1 then
				append(color.rp, n.npcpath.name.." resists arrest, but is tackled to the ground!")
				makearrest = true
					--TODO: tackled anim
			end
			if attemptnpc == 2 then
				append(color.rp, n.npcpath.name.." resists arrest, and makes a break for it!")
				event.eventcode = "arrestflee"
				makearrest = false
				event.new(1, npctoarrest, -500, player.y)
				player.dragx = nil
				player.dragy = nil
				return
			end
			if attemptnpc == 3 then
				makearrest = true
			end
			if makearrest == true then
				append(color.rp, player.factionrank.." "..player.name.." secures "..n.npcpath.name.." in cuffs.")
				append(color.lgray, "Arrested "..n.npcpath.name.." (ID "..npctoarrest..") They are in your custody.")
				n.npcpath.incuffs = true
				n.npcpath.clothes = txtrs.clothes.cuffs
			end
			elseif cmd == "arrest" or cmd == "arrest " and player.factionid == 1 then append(color.gray, "Usage: /arrest [ID]")
		end
		-- ENTER
		if cmd == "enter" then
				cmdisvalid = true
				local atenterpoint = false
				if city.hood == 2 then -- northmid player house
					if (world.x >= -50 and world.x < 25) and (world.y <= 975 and world.y >= -1025) then
						city.int = "phouse1"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.phouse1
						world.x = -50; world.y = -50
						placenpcs(999)
					end
				
				end
				if city.hood == 1 then -- clothing shop
					if (world.x <= -700 and world.x > -900) and (world.y <= -850 and world.y >= -925) then
						movecar()
						city.int = "clothes"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.clothes
						world.x = -25; world.y = -75
						placenpcs(2)
						append(color.lgray, "You enter Northside Apparel.")
					end
				end
				if city.hood == 1 then -- lakeshore tavern
					if (world.x <= -680 and world.x >= -760) and (world.y <= 100 and world.y >= 40) then
						movecar()
						city.int = "tav"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.tav
						world.x = -300; world.y = -450
						append(color.lgray, "You enter Lakeshore Tavern.")
					end
				end
				if city.hood == 5 then -- pd station
					if (world.x <= -650 and world.x > -775) and (world.y <= -125 and world.y >= -250) then
						movecar()
						city.int = "pd"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.pd
						world.x = -110; world.y = -110
						placenpcs(2)
						world.x = -50; world.y = -450
						append(color.lgray, "You enter the PPD Precinct.")
					end
				end
				if city.hood == 6 then -- fd station
					if (world.x <= -1275 and world.x > -1400) and (world.y <= -200 and world.y >= -250) then
						movecar()
						city.int = "fd"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.fd
						world.x = -300; world.y = -450
						append(color.lgray, "You enter PFD Station 1.")
					end
				end
				if city.hood == 2 then -- sub shop
					if (world.x <= -700 and world.x >= -800) and (world.y <= 50 and world.y >= -50) then
						movecar()
						city.int = "sub"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.sub
						world.x = -25; world.y = -25
						append(color.lgray, "You enter the SUB-URBAN sub shop. Use /buy or /prices.")
						append(color.lgreen, "Delivery job available! Use /deliver to begin.")
						append(color.white, "SUB-URBAN Employee: Hello.")
						pedlist.placeint("sub")
					end
				end
				if city.hood == 2 then -- gun shop
					if (world.x <= -250 and world.x >= -350) and (world.y <= 50 and world.y >= -50) then
						movecar()
						city.int = "gun"
						player.inint = true
						atenterpoint = true
						txtrs.city.txtr = txtrs.int.gun
						world.x = -25; world.y = -25
						append(color.lgray, "You enter the Patriot's Paradise gun shop. Use /buy or /prices.")
						append(color.white, "Allison Claude: Hello.")
						pedlist.placeint("gun")
					end
				end				
				if city.hood == 8 then
					-- if cords match gas station...
						n.actuallyquickgascop = true
						if (world.x <= -200 and world.x > -375) and (world.y <= -850 and world.y >= -900) then
						movecar()
							txtrs.city.txtr = txtrs.int.gas1 -- interior texture
							pedlist.placeint("qgas")
							veh.playercar.parkx = veh.playercar.drawx; veh.playercar.parky = veh.playercar.drawy
							atenterpoint = true
							player.inint = true
							city.int = "quickgas"
							updatetags()
							audio.chime:play()
							if player.dragx ~= nil then  n.npcpath.x = world.x; n.npcpath.y = world.y - 50 end -- TODO: fix (does not drag the suspect inside)
							append(color.lgray, "You enter QuickGas. Use /buy or /prices to make a purchase.")
							if player.factionid >= 3 and player.factionid <= 5 or player.factionid == 0 then append(color.dred, "You can rob this business with /robbery.") end
							append(color.white, "QuickGas Cashier: Hello.")
							world.x = 100 world.y = -50
						end
					-- if cords match liquor store...
				end
				if atenterpoint == false then append(color.gray, "No entry point found.") end
			end
		-- ROB BIZZ
		if cmd == "robbery" then
				cmdisvalid = true
				if player.factionid >= 3 and player.factionid <= 5 or player.factionid == 0 then
					append(color.gray, "What weapon will you rob the business with? Use /robbery [1-3]")
				else append(color.gray, "You cannot rob a business as a member of "..player.faction..".")
				end
			end
		if string.find(cmd, "robbery ") and cmd ~= "robbery " and cmd ~= "robbery" and ((player.factionid >= 3 and player.factionid <= 5) or player.factionid == 0) then
				local weapontouse = tonumber(string.match(cmd, "%d+"))
				local dorobbery = false
				local weaponname = nil
				local weaponname_string = nil
				if weapontouse == 1 then if player.weapons.has1 == true then dorobbery = true; weaponname_string = "9mm Pistol" else append(color.gray, "You do not have a weapon in that slot."); return end end
				if weapontouse == 2 then if player.weapons.has2 == true then dorobbery = true; weaponname_string = "Super Shorty" else append(color.gray, "You do not have a weapon in that slot."); return end end
				if weapontouse == 3 then if player.weapons.has3 == true then dorobbery = true; weaponname_string = "AK-47" else append(color.gray, "You do not have a weapon in that slot."); return end end
				if weapontouse == 0 then append(color.gray, "Weapon must be firearm."); dorobbery = false; weaponname_string = "nil" end
				if weapontouse > 3 then append(color.gray, "Valid weapon slots are 1-3."); dorobbery = false; weaponname_string = "nil" end
				-- rob the joint, yo!
				if dorobbery == true then
					append(color.rp, player.name.." draws their "..weaponname_string.." at the "..ped.ped0.name.."!")
					local shout = love.math.random(1,3)
					local shouts = {"Gimmie the money! Don't fucking stall!", "Run your shit, motherfucker!", "Fill the bag, now! You know the drill!"}
					local shoutmsg = shouts[shout]
					append(color.orange, player.name..": "..shoutmsg)
					local reaction = love.math.random(1,3)
					local reactions = {"Shit, shit! Chill out! Hold on...", "Just take it! Don't hurt me!", "Okay, okay, here. Take it!"}
					local reactionmsg = reactions[reaction]
					append(color.white, ped.ped0.name..": "..reactionmsg)
						local loot = love.math.random(250, 5,000)
						append(color.rp, ped.ped0.name.." nervously passes "..player.name.." the money.")
						append(color.lgreen, "You have robbed this business for $"..loot.."!")
						xp(love.math.random(3, 6))
				end -- end of if dorobbery
				cmdisvalid = true
			end -- if robbery confirm
		-- 	FF TEST
		if cmd == "fftest" then cmdisvalid = true doffmsg(love.math.random(1,3)) end

		-- RELOAD WEAPON
		if cmd == "reload" then
				cmdisvalid = true
				local playerhitwhilereloading = nil
				if player.weapons.selected == "glock" then
					if player.weapons.clip1 == player.weapons.maxclip1 then append(color.gray, "Your 9mm Pistol is already fully loaded!"); playerhitwhilereloading = nil; return end
					local glockfromfull = player.weapons.maxclip1 - player.weapons.clip1
					if player.weapons.ammo1 - glockfromfull < 0 then
						append(color.gray, "You are out of 9mm rounds!")
						audio.noammo:play()
						playerhitwhilereloading = nil
						return
					end
					player.weapons.clip1 = player.weapons.maxclip1
					player.weapons.ammo1 = player.weapons.ammo1 -  glockfromfull
					audio.reload_glock:play()
					append(color.rp, player.name.." slides a fresh magazine into their 9mm Pistol.")
					if n.npcpath.armed == true then playerhitwhilereloading = love.math.random(1, 4) end
				end
				if player.weapons.selected == "shorty" then
					if player.weapons.clip2 == player.weapons.maxclip2 then append(color.gray, "Your Super Shorty is already fully loaded!"); playerhitwhilereloading = nil; return end
					local shottyfromfull = player.weapons.maxclip2 - player.weapons.clip2
					if player.weapons.ammo2 - shottyfromfull < 0 then
						append(color.gray, "You are out of 12 guage shells!")
						audio.noammo:play()
						playerhitwhilereloading = nil
						return
					end
					player.weapons.clip2 = player.weapons.maxclip2
					player.weapons.ammo2 = player.weapons.ammo2 -  shottyfromfull
					audio.reload_shorty:play()
					append(color.rp, player.name.." loads some shells into their Super Shorty.")
					if n.npcpath.armed == true then playerhitwhilereloading = love.math.random(1,4) end
				end
				if player.weapons.selected == "ak" then
					if player.weapons.clip3 == player.weapons.maxclip3 then append(color.gray, "Your AK-47 is already fully loaded!"); playerhitwhilereloading = nil; return end
					local akfromfull = player.weapons.maxclip3 - player.weapons.clip3
					if player.weapons.ammo3 - akfromfull < 0 then
						append(color.gray, "You are out of 7.62 rounds!")
						audio.noammo:play()
						playerhitwhilereloading = nil
						return
					end
					player.weapons.clip3 = player.weapons.maxclip3
					player.weapons.ammo3 = player.weapons.ammo3 -  akfromfull
					append(color.rp, player.name.." jams a fresh magazine into their AK-47.")
					audio.reload_ak:play()
					if n.npcpath.armed == true then playerhitwhilereloading = love.math.random(1,4) end
				end
				if playerhitwhilereloading ~= nil then
					if playerhitwhilereloading == 4 and n.npcpath.hp > 15 and not(n.npcpath.fac == "pd" and player.factionid == 1) then playerhit(love.math.random(15, 25)); append(color.dred, "You were hit while reloading!") end
				end
			end
		-- EXIT
		if cmd == "exit" and player.inint == true then
				cmdisvalid = true
				if city.hood == 1 then txtrs.city.txtr = txtrs.city.northwest; pedlist.place(2) end
				if city.hood == 2 then txtrs.city.txtr = txtrs.city.northmid; pedlist.place(2) end
				if city.hood == 7 then txtrs.city.txtr = txtrs.city.southeast; pedlist.place(1) end
				if city.hood == 8 then txtrs.city.txtr = txtrs.city.southmid; pedlist.place(1) end
				if city.hood == 5 then txtrs.city.txtr = txtrs.city.downtown; pedlist.placeciv() end
				if city.hood == 6 then txtrs.city.txtr = txtrs.city.mideast; pedlist.placefd() end
				if city.int == "pd" then world.x = -700; world.y = -250 end
				if city.int == "fd" then world.x = -1340; world.y = -225 end
				if city.int == "quickgas" then world.x = -270; world.y = -875 end
				if city.int == "clothes" then world.x = -830; world.y = -900 end
				if city.int == "tav" then world.x = -700; world.y = 40 end
				if city.int == "sub" then world.x = -750; world.y = -50 end
				if city.int == "gun" then world.x = -45; world.y = -50 end
				if city.int == "phouse1" then world.x = -25; world.y = -1000 end
				n.actuallyquickgascop = false
				player.inint = false
				placenpcs(4)
				updatetags()
				city.int = "nil"; player.inint = false
				movecar(2)
				if player.dragx == nil then
					placenpcs(4)
					updatetags()
					n.npcpath.x = world.x; n.npcpath.y = world.y - 50
				end
				updatetags()
			elseif cmd == "exit" and player.inint == false then append(color.gray, "You are not in an interior."); cmdisvalid = true
			end
		-- GENERAL STORE BUY
		if string.find(cmd, "buy") and cmd ~= "buy" and cmd ~= "buy " and not string.find(cmd, "buydrug") then
			local itemtobuy = tonumber(string.match(cmd, "%d+"))
			cmdisvalid = true
			if city.hood == 7 then
				if itemtobuy == 1 then append(color.red, "You buy some live bait. (-$25)"); inv.bait.qnty = inv.bait.qnty + 25; player.cash = player.cash - 25 end
			if itemtobuy == 2 then
				append(color.red, "You buy a new fishing rod. (-$250)")
				inv.frod.has = true; inv.frod.hp = inv.frod.hp + 100
				player.cash = player.cash - 250
			end
			if itemtobuy == 3 then append(color.red, "You buy a fish bucket. (-$25)"); inv.fbucket.has = true player.cash = player.cash - 25 end
				cmdisvalid = true
			end
				if city.int == "sub" then
					if itemtobuy == 1 then
						append(color.red, "You buy a six inch sandwich and eat it. (-$5)")
						player.cash = player.cash - 5
						if player.hp + 25 <= 100 then player.hp = player.hp + 25 else player.hp = 100 end
					end
					if itemtobuy == 2 then
						append(color.red, "You buy a footlong sub and eat it. (-$10)")
						player.cash = player.cash - 10
						player.hp = 100
					end					
				end
				if city.int == "clothes" then
					if string.find(cmd, "buy clothes") and player.cash < 50 then append(color.gray, "You need $50 to buy new clothes."); return end
					local skintobuy = string.sub(cmd, 13, 20)
					if skintobuy ~= "" and skintobuy ~= " " then
						skin = lf.getInfo("skins/sprite/"..skintobuy..".png")
						if skin == nil then append(color.gray, "Skin '"..skintobuy.."' not found!"); return end
						anim.sprites.pskin = newAnimation(lg.newImage("skins/sprite/"..skintobuy.."f.png"), 40, 65, 1)
						anim.sprites.pskin2 = newAnimation(lg.newImage("skins/sprite/"..skintobuy.."b.png"), 40, 65, 1)
						anim.sprites.pskin3 = newAnimation(lg.newImage("skins/sprite/"..skintobuy..".png"), 40, 65, 1)
						player.cash = player.cash - 50
						player.skin = skintobuy
						append(color.red, "You have purchased new clothes. (-$50)")
					elseif skintobuy == "" or skintobuy == " " then append(color.gray, "Useage: /buy clothes [skin name]"); return
					end
				end
				if city.int == "gun" then
					if itemtobuy == 1 then
						if player.cash < 250 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy the 9mm pistol. (-$250)")
						player.weapons.has1 = true
						player.weapons.clip1 = 7
						player.cash = player.cash - 250
					end
					if itemtobuy == 2 then
						if player.cash < 1000 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy the Super Shorty. (-$1000)")
						player.weapons.has2 = true
						player.weapons.clip2 = 3
						player.cash = player.cash - 1000
					end
					if itemtobuy == 3 then
						if player.cash < 2500 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy the AK-47. (-$2500)")
						player.weapons.has3 = true
						player.weapons.clip3 = 30
						player.cash = player.cash - 2500
					end
					if itemtobuy == 4 then
						if player.cash < 50 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy x50 9mm rounds (-$100)")
						player.weapons.ammo1 = player.weapons.ammo1 + 50
						player.cash = player.cash - 100
					end
					if itemtobuy == 5 then
						if player.cash < 100 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy x25 12-guage shells (-$100)")
						player.weapons.ammo2 = player.weapons.ammo2 + 25
						player.cash = player.cash - 50
					end
					if itemtobuy == 6 then 
						if player.cash < 200 then append(color.gray, "You cannot afford that."); return end
						append(color.red, "You buy x100 7.62 rounds (-$200)")
						player.weapons.ammo3 = player.weapons.ammo3 + 100
						player.cash = player.cash - 200
					end
					
				end
				if city.int == "quickgas" then
					if itemtobuy == 1 then append(color.red, "You buy a 40oz of malt liquor. (-$10)") ; inv.fourty.qnty = inv.fourty.qnty + 1; player.cash = player.cash - 10 end
					if itemtobuy == 2 then append(color.red, "You buy a pack of gum. (-$5)"); inv.gum.qnty = inv.gum.qnty + 5; player.cash = player.cash -5 end
					if itemtobuy == 3 then append(color.red, "You buy a pack of cigarettes. (-$10)"); inv.cigs.qnty = inv.cigs.qnty + 20; player.cash = player.cash -10 end
					if itemtobuy == 4 then append(color.red, "You buy a candy bar. (-$5)"); inv.candybar.qnty = inv.candybar.qnty + 1; player.cash = player.cash - 5 end
					if itemtobuy == 5 then append(color.red, "You buy a hot coffee and drink it. (-$5)"); append(color.green, "Your sprint speed has been increased by 1!"); player.fastspeed = player.fastspeed + 1; player.cash = player.cash - 5 end -- TODO: make timer to come down from caffeine
					if itemtobuy == 6 then append(color.red, "You buy a lottery ticket. (-$10)"); player.hasticket = true; append(color.lgray, "The lottery is drawn every morning. Good luck!"); player.cash = player.cash - 10 end
				end
				if city.int ~= "quickgas" and city.int ~= "sub" and city.int ~= "clothes" and city.int ~= "gun" and city.int ~= "tavern" and city.hood ~= 7 then
					append(color.gray, "You are not at a business.")
					return
				end
			elseif (cmd == "buy" or cmd == "buy ") and (city.int == "quickgas" or city.int == "sub" or city.int == "gun") then append(color.gray, "Usage: /buy [item number]"); append(color.lgray, "Use /prices to view the cost of each item."); cmdisvalid = true
			elseif (cmd == "buy" or cmd == "buy ") and (city.hood == 7) then append(color.gray, "Usage: /buy [item] (item number])"); append(color.lgray, "Use /prices to view the cost of each item."); cmdisvalid = true
			cmdisvalid = true
			end
		-- PRICES
		if cmd == "prices" then
				cmdisvalid = true
				if city.int == "quickgas" then append(color.lgreen, "Southmid Quickgas:"); append(color.white, "(1) 40oz: $10, (2) Gum: $5, (3) Cigs: $10, (4) Candy: $5"); append(color.white, "(5) Coffee: $5 (6) Lottery ticket: $10") end
				if city.int == "tavern" then append(color.lgreen, "Lakeshore Tavern:"); append(color.white, "40oz: $4") end
				if city.int == "sub" then append(color.lgreen, "SUB-URBAN Subs"); append(color.white, "(1) 6inch sandwich: $5, (2) 12inch sandwich: $10") end
				if city.hood == 7 then append(color.lgreen, "Jack's Bait:"); append(color.white, "(1) Bait [x25]: $25, (2) Fishing rod: $250 (3) Bucket: $25") end
				if city.int == "gun" then append(color.lgreen, "Patriot's Paradise"); append(color.white, "[GUNS] (1) 9mm Pistol: $250 (2) Super Shorty: $1000 (3) AK-47: $2500"); append(color.green, "[AMMO] (4) 9mmx50: $100, (5) 12ga.x25: $50 (6) 7.62x100: $200") end
				if city.int ~= "quickgas" and city.int ~= "clothes" and city.int ~= "sub" and city.int ~= "gun" and city.int ~= "tavern" then append(color.gray, "You are not in a business.") end
			end
		-- COLOR PREVIEW
		if string.find(cmd, "color") and cmd ~= "color" and cmd ~= "color " then
				cmdisvalid = true
				local red = tonumber(string.sub(cmd, 7, 9))
				local green = tonumber(string.sub(cmd, 10, 13))
				local blue = tonumber(string.sub(cmd, 14, 17))
				if red == nil or green == nil or blue == nil then append(color.gray, "Could not fetch color. Use the 1.0 scale! Ex. 0.0, 0.0, 0.5 (blue)"); return end
				append(({red, green, blue}), "Returned RGB: "..red..", "..green..", "..blue.."!")
			elseif cmd == "color" or cmd == "color " then append(color.gray, "Usage: /color [r] [g] [b] - USE THE 0.0-1.0 SCALE!"); cmdisvalid = true
			end
		-- ROB
		if string.find(cmd, "rob") and cmd ~= "rob" and player.factionid ~= 1 and cmd ~= "robbery" and not string.find(cmd, "robbery") then
				cmdisvalid = true
				if string.find(cmd, "rob") and player.factionid == 1 then append(color.gray, "You cannot rob as a known police officer."); cmdisvalid = true end
				local npctorob = tonumber(string.match(cmd, "%d+"))
				local hasweapon = false
				getpath(npctorob)
				checkproxi()
				if n.canY == true and n.canX == true then
				if player.weapons.slot1 ~= "fists" and player.weapons.slot2 ~= "fists" and player.weaponslot3 ~= "fists" then hasweapon = true end
				if n.npcpath.wasrobbed == true then append(color.gray, "You have already robbed "..n.npcpath.name..".") end
				if hasweapon == true and n.npcpath.wasrobbed == false then
					cscript.runcmd("/equip 1")
					if player.weapons.slot1 == "Glock 17" then player.weapons.weapontxtr = txtrs.weapons.glockr end
					if player.weapons.slot1 == "Super Shorty" then player.weapons.weapontxtr = txtrs.weapons.shortyr;  end
					if player.weapons.slot1 == "AK-47" then player.weapons.weapontxtr = txtrs.weapons.akr end
					append(color.rp, player.name.." holds "..n.npcpath.name.." at gunpoint!")
					local robreaction = love.math.random(1,4)
					if robreaction == 1 then append(color.white, n.npcpath.name..": Take it, take it! Don't hurt me!"); xp(love.math.random(2, 4)) end
					if robreaction == 2 then append(color.white, n.npcpath.name..": You're gonna' pay for this..."); xp(love.math.random(2, 4)) end
					if robreaction == 3 then append(color.white, n.npcpath.name..": Easy, easy! Here's all I got."); xp(love.math.random(2, 4)) end
					if robreaction == 4 then append(color.white, n.npcpath.name..": Man, fuck you, fool!"); n.npcpath.holstered = false; playerhit(love.math.random(10, 25)) end
					-- TODO: npc provoked
					local cashamount = love.math.random(1,3)
					local cashrobbed = 0
					local weedrobbed = love.math.random(0,3)
					local cokerobbed = love.math.random(0,3)
					if not string.find(n.npcpath.fac, "gang") then weedrobbed = 0; cokerobbed = 0 end
					if string.find(n.npcpath.fac, "dealer") then weedrobbed = love.math.random(0,10); cokerobbed = love.math.random(0,10) end
					if cashamount == 1 then cashrobbed = love.math.random(5, 100) end
					if cashamount == 2 then cashrobbed = love.math.random(100, 250) end
					if cashamount == 3 then cashrobbed = love.math.random(250, 1000) end
					local snitch = love.math.random(1,3)
					append(color.lgreen, "You robbed "..n.npcpath.name.." for $"..cashrobbed.."!")
					if weedrobbed > 0 then append(color.lgreen, "...and "..weedrobbed.."g of weed!"); inv.weed.qnty = inv.weed.qnty + weedrobbed end
					if cokerobbed > 0 then append(color.lgreen, "...and "..cokerobbed.."g of coke!"); inv.coke.qnty = inv.coke.qnty + cokerobbed end					
					player.cash = player.cash + cashrobbed
					if snitch == 3 and player.faction ~= 1 then append(color.red, "You hear sirens in the distance."); audio.sirens:play(); player.wanted = true end
					n.npcpath.wasrobbed = true
				end
				else append(color.gray, "You are not close enough to that ped.")
				end
				if cmd == "rob" and player.factionid ~= 1 then append(color.gray, "Usage: /rob [ID]") end
		end
		-- COLOR TEST
		if cmd == "ctest" then
			cmdisvalid = true
			append(color.black, "BLACK")
			append(color.gray, "GRAY")
			append(color.lgray, "LGRAY")
			append(color.white, "WHITE")
			append(color.rp, "RP")
			append(color.red, "RED")
			append(color.dred, "DRED")
			append(color.orange, "ORANGE")
			append(color.yellow, "YELLOW")
			append(color.green, "GREEN")
		end
		if cmd == "ctest2" then
			cmdisvalid = true
			append(color.lgreen, "LGREEN")
			append(color.lblue, "GRAY")
			append(color.blue, "LGRAY")
			append(color.purple, "WHITE")
			append(color.gray, "Color test completed.")
		end
		-- GET NPC
		if string.find(cmd, "get") and cmd ~= "get" and cmd ~= "get " and not string.find(cmd, "target") then
				cmdisvalid = true
				local npctoget = tonumber(string.match(cmd, "%d+"))
				getpath(npctoget)
				n.npcpath.x = player.x
				n.npcpath.y = player.y
				updatetags()
				append(color.lblue, "Teleported "..n.npcpath.name.." (ID "..npctoget..") to player.")
				if cmd == "get" or cmd == "get " then append(color.gray, "Usage: /get [ID]") end
		end
		-- FIND/GOTO NPC
		if string.find(cmd, "find") and cmd ~= "find" and cmd ~= "find " then
				local npctofind = tonumber(string.match(cmd, "%d+"))
				getpath(npctofind)
				world.x = n.npcpath.x
				world.y = n.npcpath.y
				updatetags()
				append(color.lblue, "Found  "..n.npcpath.name.." (ID "..npctofind..") at "..n.npcpath.x..", "..n.npcpath.y.."!")
				cmdisvalid = true
				if cmd == "find" or cmd == "find " then  append(color.gray, "Usage: /find [ID]"); cmdisvalid = true end
		end		
		-- PRICE DRUG
		if string.find(cmd, "priceweed") and cmd ~= "priceweed" and cmd ~= "priceweed " then
			cmdisvalid = true
			local wprice = tonumber(string.match(cmd, "%d+"))
			player.priceweed = wprice
			append(color.lgray, "You are now charging $"..wprice.." per gram of weed.")
		elseif cmd == "priceweed" or cmd == "priceweed " then append(color.gray, "Usage: /priceweed [price] You currently charge $"..player.priceweed.." per gram."); cmdisvalid = true
		end
		if string.find(cmd, "pricecoke") and cmd ~= "pricecoke" and cmd ~= "pricecoke" then
			cmdisvalid = true
			local cprice = tonumber(string.match(cmd, "%d+"))
			player.pricecoke = cprice
			append(color.lgray, "You are now charging $"..cprice.." per gram of coke.")
		elseif cmd == "pricecoke" or cmd == "pricecoke " then append(color.gray, "Usage: /pricecoke [price] You currently charge $"..player.pricecoke.." per gram."); cmdisvalid = true
		end
		-- UPSHIFT
		if cmd == "upshift" then
				cmdisvalid = true
				if player.incar == true then
				local newgear = veh.playercar.gear + 1
				local doupshift = true
				local dodrive = false
				if newgear == 1 then dodrive = true; doupshift = false end
				if newgear > veh.playercar.gears then doupshift = false end
				if dodrive == true then
					append(color.rp, player.name.." shifts the "..veh.playercar.name.. " into drive.")
					player.incar = true
					veh.playercar.gear = 1
					veh.playercar.speed = 2 -- starter speed (TODO: load from veh's data in vehdata.lua)
					veh.playercar.isparked = false
					veh.playercar.rounded = -1.6
				end
				if doupshift == true then
					append(color.rp, player.name.." upshifts the "..veh.playercar.name.." into gear "..newgear..".")
					veh.playercar.gear = newgear
					local vehdatapath = nil
					if veh.playercar.name == "Police Cruiser" then vehdatapath = vehdata.cruiser end
					if veh.playercar.name == "Roadrunner" then vehdatapath = vehdata.rig1 end
					if veh.playercar.name == "Taxi Cab" then vehdatapath = vehdata.cab1 end
					veh.playercar.speed = 2 + (vehdatapath.ratio * newgear)
					veh.playercar.gears = vehdatapath.gears
				elseif doupshift == false and dodrive == false and player.incar == true then append(color.gray, "You have reached this "..veh.playercar.name.."'s top forward gear!")
				end
				elseif player.incar == false then
					append(color.gray, "You are not in a car.")
				end
			end
		-- DOWNSHIFT
		if cmd == "downshift" then
				cmdisvalid = true
				if player.incar == true then
				local newgear = veh.playercar.gear - 1
				local dodnshift = true
				local dopark = false
				if player.incar == false then dodnshift = false; dopark = false end
				if newgear < 1 then dodnshift = false; dopark = true end
				if dopark == true then
					append(color.rp, player.name.." shifts the "..veh.playercar.name.. " into park.")
					veh.playercar.gear = 0
					veh.playercar.speed = 0 -- starter speed (TODO: load from veh's data in vehdata.lua)
					veh.playercar.isparked = true
				end
				if dodnshift == true then
					append(color.rp, player.name.." shifts from gear "..veh.playercar.gear.." to gear "..newgear..".")
					veh.playercar.gear = newgear
					veh.playercar.speed = (veh.playercar.gear * 2) -- makeshift gear ratios (TODO: load from veh's data in vehdata.lua)
				end
				elseif player.incar == false then
					append(color.gray, "You are not in a car.")
				end
			end
		-- ENTER/EXIT VEHICLE
		if cmd == "car" then
				-- TODO: proximity checker
				if player.incar == false then append(color.gray, "Entering "..veh.playercar.name.."..."); player.speed = 0; player.canmove = false; player.incar = true; veh.playercar.drawx = 295; veh.playercar.drawy = 295; veh.playercar.isparked = false return end -- 275 290
				if player.incar == true then append(color.gray, "Exiting "..veh.playercar.name.."..."); player.speed = player.regularspeed; player.canmove = true; player.incar = false; veh.playercar.isparked = true; return end
			end
		-- SPAWN VEHICLE
		if string.find(cmd, "v") and cmd ~= "v" and cmd ~= "v " and not string.find(cmd, "civ") and not string.find(cmd, "save") and not string.find(cmd, "deliver") and not string.find(cmd, "load") and not string.find(cmd, "version") and not string.find(cmd, "revive") and not string.find(cmd, "inv") and not string.find(cmd, "travel") and not string.find(cmd, "devmode") then
				cmdisvalid = true
				local vehtospawn = nil
				local voutput = string.sub(cmd, 3, 20)
					print("[debug] searching for vehicle '"..voutput.."'.")
				if txtrs.vehs[voutput] then
					local vdatapath = nil
					if voutput == "cruiser1" or voutput == "cruiser2" then vdatapath = vehdata.cruiser end
					if voutput == "rig1"then vdatapath = vehdata.rig1 end
					if voutput == "cab1" then vdatapath = vehdata.cab1 end
					append(color.lgray, ("Spawned a '"..voutput.."'."))
					veh.playercar.txtr = txtrs.vehs[voutput]
					veh.playercar.isparked = true
					veh.playercar.speed = 0
					veh.playercar.gear = 0
					veh.playercar.face = 1
					veh.playercar.hp = 999
					veh.playercar.name = vdatapath.name
					veh.playercar.gears = vdatapath.gears
					player.incar = true
					player.speed = 0
					append(color.lblue, "["..veh.playercar.name.."]: P: 0".." 1: 1".." 2: "..(2 + veh.playercar.ratio).." 3:"..(3 + veh.playercar.ratio).." 4: "..(4 + veh.playercar.ratio).." 5: "..(5 + veh.playercar.ratio))
					if txtrs.sky == txtrs.sky2 then veh.playercar.lights = false else veh.playercar.lights = true end
					veh.playercar.drawx = player.x - 25; veh.playercar.drawy = player.y + 50
				else append(color.gray, ("Vehicle '"..voutput.."' could not be found."))
				end
				elseif cmd == "v" or cmd == "v " then append(color.gray, "Usage: /v [vehicle name]")
				return
			end
		-- SET WANTED
		if cmd == "set wanted" then
				if player.wanted == true then
					append(color.lgreen, "Clearing wanted status.")
					player.wanted = false
					return
				end
				if player.wanted == false then
					append(color.red, "Giving wanted status.")
					player.wanted = true
				end
			end
		-- SET PLAYERCAR ROT
		if string.find(cmd, "set pcrot") and cmd ~= "set pcrot" and cmd ~= "set pcrot " then
				cmdisvalid = true
				local radtoset = tonumber(string.sub(cmd, 10, 14))
				veh.playercar.rot = radtoset
				append(color.lgray, "Set player car rotation to "..radtoset.." radians.")
				elseif cmd == "set pcrot" or cmd == "set pcrot " then append(color.gray, "Usage: /set pcrot [radians]")
				return
			end
		-- MENU
		if cmd == "menu" or cmd == "log" or cmd == "logout" then
				append(color.lgray, "Exiting to start menu.")
				smenu.draw()
				smenu.update()
				audio.smenu:play()
				n.sdata.input = false
				n.sdata.inputcode = 999
				graphics.timeofday = 0
				graphics.dayornight = "day"
				n.smenu = true
				n.sdata.play = false
			end
		-- DESCRIBE NPC
		if string.find(cmd, "desc") and cmd ~= "desc" and cmd ~= "desc " then
				cmdisvalid = true
				local npctodesc = tonumber(string.match(cmd, "%d+"))
				local dodesc = true
				getpath(npctodesc)
				-- TODO: proximity checker
				if dodesc == true then
					append(color.rp, n.npcpath.name.." is "..n.npcpath.desc..".")
				elseif cmd == "desc" or cmd == "desc " then  append(color.gray, "Usage: /desc [ID]")
				end
		end
		-- CHAT
		if string.find(cmd, "chat") and cmd ~= "chat " then
				cmdisvalid = true
				local npctochat = tonumber(string.match(cmd, "%d+"))
				if npctochat == nil then
					if n.npcpath == peds.ped0 then npctochat = 0 end
					if n.npcpath == peds.ped1 then npctochat = 1 end
					if n.npcpath == peds.ped2 then npctochat = 2 end
					if n.npcpath == peds.ped3 then npctochat = 3 end
					if n.npcpath == peds.ped4 then npctochat = 4 end
					if n.npcpath == peds.ped5 then npctochat = 5 end
					if n.npcpath == peds.ped6 then npctochat = 6 end
					if n.npcpath == peds.ped7 then npctochat = 7 end
					if n.npcpath == peds.ped8 then npctochat = 8 end
					if n.npcpath == peds.ped9 then npctochat = 9 end
				end
				local dochat = true
				local chatmsg = nil
				local msg = nil
				getpath(npctochat)
				-- TODO: proximity checker
				if dochat == true then
					chatmsg = love.math.random(1,3)
					-- if npc is dead, no dialog:
					if n.npcpath.hp <= 10 and n.npcpath.hp > 0 then msg = "(groan)" return end
					if n.npcpath.hp < 0 then append(color.rp, n.npcpath.name.." lies dead on the ground."); append(color.gray, "You cannot chat with a dead man."); return end
					-- toggle options box, click handler
					dialog.active = true -- start post-0.28 dialog
					-- start of pre-0.28 dialog
					if (n.npcpath.fac == "civilian" or n.npcpath.fac == "truck") and player.factionid == 1 then -- IF PED IS CIV OR TRUCKER
						replies = {"Having a good day, officer?", "Hello, officer.", "Catch any thugs lately?"} -- POST 0.28 DIALOG
						msg = replies[chatmsg]
					end -- end of talking to civ/trucker as cop (faction ids 0 and 6)
					function greply_deal()
						return
					end
					function greply_good(g)
							replies = {"W'sup?", "'Ey, blood..", "What's good, homie?"}
							if g == true then replies = {"Que pasa, amigo?", "'Ey, vato.", "Hola."} end
							msg = replies[chatmsg]
					end
					function greply_bad(g)
						replies = {"This ain't your hood, punk.", "Get the fuck outta' here.", "You got a death wish, fool?"} -- POST 0.28 DIALOG
						if g == true then replies = {"Keep walking, holmes.", "Fuck off, cabron.", "You lost, ese?"} end
						dialog.options = {"I was just leaving.", "I'm just looking to buy."}
						msg = replies[chatmsg]
					end
					if n.npcpath.fac == "gang2"  then -- IF PED IS GREEN
						if player.factionid == 4 then greply_good(false) end
						if player.factionid ~= 4 then greply_bad(false)	end
					end -- end of if npc is gang1 (fac id 3)
					if n.npcpath.fac == "gang1"  then -- IF PED IS PURPLE
						if player.factionid == 3 then greply_good(false) end
					if player.factionid ~= 3 then greply_bad(false)	end
					end -- end of if npc is gang1 (fac id 3)
					if n.npcpath.fac == "gang3"  then -- IF PED IS BLUE
						if player.factionid == 5 then greply_good(true)	end
						if player.factionid ~= 5 then greply_bad(true) end
					end -- end of if npc is gang3 (fac id 5) END OF GANG CHECKS
						if n.npcpath.fac == "pd" then -- IF PED IS PD
							if player.factionid == 1 or player.factionid == 2 then
								if player.factionrankid > n.npcpath.facrank or player.factionrankid == 5 then
									local sirormaam = "sir"
										if player.race == "wma" or player.race == "bma" or player.race == "hma" then sirormaam = "sir" end
										if player.race == "wfa" or player.race == "bfa" or player.race == "hfa" then sirormaam = "ma'am" end
											local names = {}
											names[1], names[2] = player.name:match("(%w+)(.+)")
											replies = {"How's your shift going, "..sirormaam.."?", "Call me in if you need backup, "..sirormaam..".", "Hello "..player.factionrank..""..names[2].."."}
											msg = replies[chatmsg]
									end -- end of if player is higher rank
								if n.npcpath.facrank >= player.factionrankid then
										replies = {"How's your shift going?", "Call me in if you need backup.", "Another day, another dollar."}
										msg = replies[chatmsg]
									end -- end of if ped is equal
								end -- end if if talking to fellow cop
							end -- end of ped is fellow cop
						if player.factionid >= 3 and player.factionid <= 5 and n.npcpath.fac == "pd" then -- IF PLAYER IS GANG
							replies = {"You better keep your nose clean.", "Don't bother me with your problems.", "Keep it moving."}
							msg = replies[chatmsg]
						end -- end of if talking to cop as gangster
					if n.npcpath.fac == "dealer" or n.npcpath.fac == "gang1" or n.npcpath.fac == "gang2" or n.npcpath.fac == "gang3" then
						if player.factionid == 1 then
							replies = {"You need something, pig?", "This ain't a donut shop, narc.", "Fuck you, Five-O."}
							msg = replies[chatmsg]
							local offertocop = love.math.random(1,3)
							local offermsg = love.math.random(1,3)
							offers = {"Didn't know cops liked to party, too...", "You lookin', officer?", "Yo, cash upfront, pig."}
							if offertocop == 3 then msg = offers[offermsg]
								append(color.lgray, "Use /reply [A]: (Arrest) [B]: Shh, keep it down! [C]: No thanks."); n.talkingto = "dealer"; n.selltocopauth = false; cmdisvalid = true
							end
						end
					end
					if player.factionid ~= 1 and n.npcpath.fac ~= "pd" and n.npcpath.name ~= "QuickGas Cashier" and (n.npcpath.fac == string.find(cmd, "gang") or n.npcpath.fac == "dealer") then
								offers = {"Looking for a lil' somethin', somethin'?", "Psst, lookin' to buy?", "Whatcha' need?"}
								msg = offers[chatmsg]
								append(color.lgray, "Use /reply [A]: Buy coke [B]: Buy weed [C]: No thanks."); n.talkingto = "dealer"; cmdisvalid = true
					end
					if player.factionid ~= 1 and player.factionid ~= 3 and player.factionid ~= 4 and player.factionid ~= 5 and n.npcpath.fac == "pd" then
						replies = {"How's it going?", "Enjoying your day?", "Remember to call 911 if you see anything."}
						msg = replies[chatmsg]
					end
					if n.npcpath.fac == "civilian" and player.factionid ~= 1 then
						replies = {"Uh...Hey.", "How's it going?", "Need something?"}
						msg = replies[chatmsg]
					end
					if msg == nil then msg = "Hey there." end
					append(color.white, n.npcpath.name..": "..msg)
				end -- end of if dochat
				talkingto = n.npcpath
				elseif cmd == "chat " then  append(color.gray, "Usage: /chat [ID] (or target ped and /chat)")
		end
		-- TUNE CAR RADIO
	if string.find(cmd, "radio") and cmd ~= "radio" then
		if veh.playercar.isparked == true then append(color.gray, "You are not in your car."); return end
	local stationtotune = tonumber(string.match(cmd, "%d+"))
	local stationname = nil
	if stationtotune ~= nil and stationtotune > 0 and stationtotune < 4 then
		append(color.rp, player.name.." reaches down to their radio, and retunes it.")
		if stationtotune == 1 then stationname = "Parkwood JAMz" end
		if stationtotune == 2 then stationname = "indiE-FM" end
		if stationtotune == 3 then stationname = "Radio Loko" end
		append(color.lgray, "You have tuned this "..veh.playercar.name.."'s radio to "..stationname..".")
		cmdisvalid = true
	else append(color.gray, "Station not recognized or you are out of range.")
	end -- end of if station slot valid
	elseif cmd == "radio" then append(color.gray, "Usage: /radio [station number 1-3]"); append(color.lgray, "Stations in range: (1) Parkwood JAMz (2) indiE-FM (3) Radio Loco")
	cmdisvalid = true
	end
		-- REPLY
		if string.find(cmd, "reply") and cmd ~= "reply" and cmd ~= "reply " and talkingto ~= nil then
		cmdisvalid = true
		local option = string.sub(cmd, 7)
		if n.npcpath.fac == "dealer" or n.npcpath.fac == "gang1" or n.npcpath.fac == "gang2" or n.npcpath.fac == "gang3" then
			local selltocop = 0
			if player.factionid == 1 then if option == "a" and n.selltocopauth == false then append(color.white, player.name..": Got something you shouldn't have?") cscript.runcmd("/arrest "..n.npcpathid); n.buying = nil end end
			if player.factionid == 1 then if option == "b" and n.selltocopauth == false then
				selltocop = love.math.random(1,3)
				if selltocop == 3 or n.selltocopauth == true then
					append(color.white, n.npcpath.name..": Well place your order already, then.")
					append(color.lgray, "Use /reply [A]: Buy coke [B]: Buy weed [C]: Never mind.")
					n.selltocopauth = true
					return
				else append(color.white, n.npcpath.name..": I can't help you, narc."); n.selltocopauth = false; selltocop = 0
				return
				end
			end
			end
			if player.factionid == 1 then if option == "c" then append(color.white, n.npcpath.name..": That's right, keep walking, then."); n.buying = nil end end
			if option == "a" and player.factionid ~= 1 then append(color.white, n.npcpath.name..": Snow White? How much you need?"); append(color.gray, "Use /buydrug [amount] to make a deal."); n.buying = "coke"; return end
			if option == "b" and player.factionid ~= 1 then append(color.white, n.npcpath.name..": Herb? How much you need?"); append(color.gray, "Use /buydrug [amount] to make a deal."); n.buying = "weed"; return end
			if option == "c" and player.factionid ~= 1 then append(color.white, n.npcpath.name..": Whatever, lemmie know if you change your mind."); n.buying = nil; return end
			if option == "a" and player.factionid == 1 and n.selltocopauth == true then append(color.white, n.npcpath.name..": Snow White? How much you need?"); append(color.gray, "Use /buydrug [amount] to make a deal."); n.buying = "coke"; return end
			if option == "b" and player.factionid == 1 and n.selltocopauth == true then append(color.white, n.npcpath.name..": Herb? How much you need?"); append(color.gray, "Use /buydrug [amount] to make a deal."); n.buying = "weed"; return end
		end -- end of if ped is dealer
	elseif cmd == "reply" or cmd == "reply " then append(color.gray, "Usage: /reply [A/B/C]")
	end
		-- OFFERDRUG
		if string.find(cmd, "offerdrug") then
			local pedtosellto = tonumber(string.match(cmd, "%d+"))
			if pedtosellto == nil then pedtosellto = n.npcpathid end
			getpath(pedtosellto)
			checkproxi()
			if n.canX == false or n.canY == false then append(color.gray, "You are not close enough to that ped.") return end
			local pedwants = love.math.random(1,3)
			local pedneeds = nil
			local dooffer = false
			if (inv.weed.qnty <= 0 and inv.coke.qnty <= 0) then dooffer = true elseif (inv.weed.qnty <= 0 and inv.coke.qnty <= 0) then append(color.gray, "You do not have any drugs to offer.") end
			if n.npcpath.fac == "pd" then append(color.gray, "You cannot street-sell drugs to a police officer."); return end
			if n.npcpath.fac ~= "pd" then
				if pedwants == 1 then -- ped wants coke
					append(color.white, n.npcpath.name..": Got any white?")
					pedneeds = love.math.random(1, (inv.coke.qnty - (inv.coke.qnty / 2)))
					if inv.coke.qnty <= 0 then append(color.gray, "You do not have any coke to sell to "..n.npcpath.name.."."); n.canselldrug = false return end
					if pedneeds == 1 then append(color.lgray, "The buyer needs 1 gram. Use /selldrug to make the deal.") end
					if pedneeds > 1 then append(color.lgray, "The buyer needs "..pedneeds.." grams. Use /selldrug to make the deal.") end
					n.canselldrug = true; n.tosell = "coke"; n.sellamount = pedneeds
				end -- end of ped wants coke
				if pedwants == 2 then -- ped wants weed
					append(color.white, n.npcpath.name..": Got any herb?")
					pedneeds =love.math.random(1, (inv.weed.qnty - (inv.weed.qnty / 2)))
					if inv.weed.qnty <= 0 then append(color.gray, "You do not have any weed to sell to "..n.npcpath.name.."."); n.canselldrug = false return end
					if pedneeds == 1 then append(color.lgray, "The buyer needs 1 gram. Use /selldrug to make the deal.") end
					if pedneeds > 1 then append(color.lgray, "The buyer needs "..pedneeds.." grams. Use /selldrug to make the deal.") end
					n.canselldrug = true; n.tosell = "weed"; n.sellamount = pedneeds
				end
				if pedwants == 3 then -- ped does not want drugs
					append(color.white, n.npcpath.name..": No thanks.")
					n.canselldrug = false; n.tosell = nil; n.sellamount = nil
				end
		end -- end of if ped buying is NOT cop
		cmdisvalid = true
	end
		-- SELLDRUG
		if string.find(cmd, "selldrug") then
			cmdisvalid = true
			if n.canselldrug == true then
				selldrug(n.tosell, n.sellamount)
				return
			end
			if n.canselldrug == false then
				append(color.gray, "You have not offered drugs to anyone.")
			end
		end
		-- HEYSOYAM
		if cmd == "hesoyam" then
		cmdisvalid = true
		player.cash = player.cash + 250000
		player.hp = 100
		player.ap = 100
		append(color.gray, "Cheat activated.")
	end
		-- FULLCLIP
		if cmd == "fullclip" then
		if n.cheats.fullclip == false then
			cmdisvalid = true
			player.weapons.clip1 = 999
			player.weapons.clip2 = 999
			player.weapons.clip3 = 999
			append(color.gray, "Cheat activated.")
			n.cheats.fullclip = true
			return
			end
		if n.cheats.fullclip == true then cmdisvalid = true; player.weapons.clip1 = 7; player.weapons.clip2 = 3; player.weapons.clip3 = 30; append(color.gray, "Cheat deactivated."); n.cheats.fullclip = false end
	end
		-- BUYDRUG
		if string.find(cmd, "buydrug") and cmd ~= "buydrug" and cmd ~= "buydrug " and not string.find(cmd, "offerdrug") then
		cmdisvalid = true
		if n.buying == nil then append(color.gray, "You are not in a drug deal.") return end
		local tobuy = string.match(cmd, "%d+")
		if tobuy ~= nil then
			buydrug(n.buying, tonumber(string.match(cmd, "%d+")))
		end
	elseif cmd == "buydrug" or cmd == "buydrug " then append(color.gray, "Usage: /buydrug [quantity]")
	cmdisvalid = true
	end
	-- CHECK BUCKET
	if cmd == "bucket" then
		cmdisvalid = true
		if inv.fbucket.has == true then
			append(color.rp, player.name.." glances into their fishing bucket.")
			append(color.blue, "Your bucket contains...")
			append(color.white, "- "..inv.fbucket.slot1_weight.." lb "..inv.fbucket.slot1_breed)
			append(color.white, "- "..inv.fbucket.slot2_weight.." lb "..inv.fbucket.slot2_breed)
			append(color.white, "- "..inv.fbucket.slot3_weight.." lb "..inv.fbucket.slot3_breed)
			append(color.white, "- "..inv.fbucket.slot4_weight.." lb "..inv.fbucket.slot4_breed)
			append(color.white, "- "..inv.fbucket.slot5_weight.." lb "..inv.fbucket.slot5_breed)
			append(color.blue, "Fishing bait: ["..inv.bait.qnty.."] - Rod durability: ["..inv.frod.hp.."]")
		else append(color.gray, "You do not have a fishing bucket.")
		end
	end
	-- FISH
	if cmd == "fish" and (city.hood == 1 or city.hood == 4 or city.hood == 7) then
		if inv.frod.has == true and inv.frod.hp >= 0 then
		if inv.fbucket.has == true then
		if inv.bait.qnty > 0 then
		if inv.fbucket.slot5_weight > 0 then append(color.gray, "Your bucket is full! Sell it first. (/sellfish)"); return end
			if event.eventcode == "fishwait" then append(color.gray, "You are already fishing."); return else event.new(5, nil, nil, nil) end
			append(color.rp, player.name.." casts their fishing rod.")
			player.clothes.torso = txtrs.clothes.frod; player.clothes.torsoX = player.x - 8
			if (inv.frod.hp - 1) > 0 then inv.frod.hp = inv.frod.hp - 1 else append(color.red, "Your fishing rod becomes overstressed, and snaps!"); player.clothes.torso = txtrs.clothes.none; inv.frod.has = false end
			-- ...
			cmdisvalid = true
		elseif inv.bait.qnty <= 0 then append(color.gray, "You are out of fishing bait."); return
		end
		elseif inv.fbucket.has == false then append(color.gray, "You do not have a fishing bucket."); return
		end -- end of if has fbucket
		elseif inv.frod.has == false or inv.frod.hp <= 0 then append(color.gray, "You do not have a fishing rod."); return
		end -- end of if has frod
		elseif cmd == "fish" and city.hood ~= 1 and city.hood ~= 4 and city.hood ~= 7 then append(color.gray, "You cannot fish here. You must be near water.")
		cmdisvalid = true
	end -- end of /fish
	if cmd == "sellfish" and city.hood == 7 then
		cmdisvalid = true
		if inv.fbucket.has == true then
			local s1worth = inv.fbucket.slot1_weight * inv.fbucket.slot1_worth
			local s2worth = inv.fbucket.slot2_weight * inv.fbucket.slot2_worth
			local s3worth = inv.fbucket.slot3_weight * inv.fbucket.slot3_worth
			local s4worth = inv.fbucket.slot4_weight * inv.fbucket.slot4_worth
			local s5worth = inv.fbucket.slot5_weight * inv.fbucket.slot5_worth
			local totalworth = s1worth + s2worth + s3worth + s4worth + s5worth
			if s1worth == 0 and s2worth == 0 and s3worth == 0 and s4worth == 0 and s5worth == 0 then append(color.gray, "Your bucket is empty."); return end
			append(color.lgreen, "YOU HAVE SOLD:")
			append(color.white, "- x1 "..inv.fbucket.slot1_breed.." ("..inv.fbucket.slot1_weight.." lbs at $"..inv.fbucket.slot1_worth.." / lb): $"..s1worth)
			append(color.white, "- x1 "..inv.fbucket.slot2_breed.." ("..inv.fbucket.slot2_weight.." lbs at $"..inv.fbucket.slot2_worth.." / lb): $"..s2worth)
			append(color.white, "- x1 "..inv.fbucket.slot3_breed.." ("..inv.fbucket.slot3_weight.." lbs at $"..inv.fbucket.slot3_worth.." / lb): $"..s3worth)
			append(color.white, "- x1 "..inv.fbucket.slot4_breed.." ("..inv.fbucket.slot4_weight.." lbs at $"..inv.fbucket.slot4_worth.." / lb): $"..s4worth)
			append(color.white, "- x1 "..inv.fbucket.slot5_breed.." ("..inv.fbucket.slot5_weight.." lbs at $"..inv.fbucket.slot5_worth.." / lb): $"..s5worth)
			append(color.lgreen, "...for a total value of: $"..totalworth)
			player.cash = player.cash + totalworth
			inv.fbucket.slot1_weight = 0; inv.fbucket.slot1_breed = "nil"; inv.fbucket.slot1_worth = 0
			inv.fbucket.slot2_weight = 0; inv.fbucket.slot2_breed = "nil"; inv.fbucket.slot2_worth = 0
			inv.fbucket.slot3_weight = 0; inv.fbucket.slot3_breed = "nil"; inv.fbucket.slot3_worth = 0
			inv.fbucket.slot4_weight = 0; inv.fbucket.slot4_breed = "nil"; inv.fbucket.slot4_worth = 0
			inv.fbucket.slot5_weight = 0; inv.fbucket.slot5_breed = "nil"; inv.fbucket.slot5_worth = 0
		elseif inv.fbucket.has == false then append(color.gry, "You do not have a fishing bucket to sell."); return
		end -- end of if hasfbucket	
	elseif cmd == "sellfish" and city.hood ~= 7 then append(color.gray, "You must be at the bait shop in The Dockyards to sell fish."); return
	end -- end of sellbucket
	if cmd == "duty on" then
		if player.factionid == 1 then
			if city.int == "pd" then
				if player.factionduty == true then append(color.gray, "You are already on duty."); return end
				local names = {}
				names[1], names[2] = player.name:match("(%w+)(.+)")
				append(color.rp, player.name.." changes into their duty uniform.")
				append(color.blue, player.factionrank..""..names[2].." is now on duty!")
				player.has1 = true; player.clip1 = 7; player.ammo1 = 98
				player.ap = 100; player.maxap = 100
				player.hp = 100; player.maxhp = 100
				append(color.lgray, "Use /fcar outside to spawn your patrol car.")
				player.odskin = anim.sprites.pskin; player.odskin = anim.pskin2; player.odskin = anim.pskin3
				player.factionduty = true
				local uniform1 = nil; local uniform2 = nil; local uniform3 = nil -- dn; up; idle
				if player.race == "bma" then uniform1 = lg.newImage("skins/sprite/cop1f.png"); uniform2 = lg.newImage("skins/sprite/cop1b.png"); uniform3 = lg.newImage("skins/sprite/cop1.png") end
				if player.race == "wma" then uniform1 = lg.newImage("skins/sprite/cop2f.png"); uniform2 = lg.newImage("skins/sprite/cop2b.png"); uniform3 = lg.newImage("skins/sprite/cop2.png") end
				if player.race == "wma" and player.factionrankid < 3 then uniform1 = lg.newImage("skins/sprite/cop2f.png"); uniform2 = lg.newImage("skins/sprite/cop2b.png"); uniform3 =  lg.newImage("skins/sprite/cop2.png") end
				if player.race == "wma" and player.factionrankid >= 3 then uniform1 = lg.newImage("skins/sprite/cop3f.png"); uniform2 = lg.newImage("skins/sprite/cop3b.png"); uniform3 =  lg.newImage("skins/sprite/cop3.png") end
				if player.race == "wma" and player.factionrankid >= 3 then uniform1 = lg.newImage("skins/sprite/cop3f.png"); uniform2 = lg.newImage("skins/sprite/cop3b.png"); uniform3 =  lg.newImage("skins/sprite/cop3.png") end
				if player.race == "wfa" then uniform1 = lg.newImage("skins/sprite/cop4f.png"); uniform2 = lg.newImage("skins/sprite/cop4b.png"); uniform3 =  lg.newImage("skins/sprite/cop4.png") end
				if player.race == "bfa" or player.race == "hma" or player.race == "hfa" then
					append(color.lblue, "[debug] no pd skin for player's race, using swat1...")
					uniform1 = lg.newImage("skins/sprite/swat1f.png"); uniform2 = lg.newImage("skins/sprite/swat1b.png"); uniform3 = lg.newImage("skins/sprite/swat.png")
				end
				anim.sprites.pskin = newAnimation(uniform1, 40, 65, 2) 
				anim.sprites.pskin2 = newAnimation(uniform2, 40, 65, 2)
				anim.sprites.pskin3 = newAnimation(uniform3, 40, 65, 45)
			elseif city.int == "pd" then append(color.gray, "You are not at the police station.")
			end -- end of if at pd station
		end
		if player.factionid == 2 then
			if city.int == "fd" then
				if player.factionduty == true then append(color.gray, "You are already on duty."); return end
				local names = {}
				names[1], names[2] = player.name:match("(%w+)(.+)")
				append(color.dred, player.factionrank..""..names[2].." is now on duty.")
				append(color.rp, player.name.." changes into their duty uniform.")
				local uniform1 = nil; local uniform2 = nil; local uniform3 = nil -- dn; up; idle
				append(color.red, "[debug] no fd sprites! will not set skin.")
				player.factionduty = true
			elseif city.int ~= "fd" then append(color.gray, "You are not at the fire station.")
			end -- end of if in fd station
		end
		if player.factionid ~= 1 and player.factionid ~= 2 then append(color.gray, "You are not a member of PPD or PFD.") end
		cmdisvalid = true
	end -- end of duty on
	if cmd == "duty off" then
		if player.factionid == 1 then
			if player.factionduty == false then append(color.gray, "You are already off duty."); return end
			local names = {}
			names[1], names[2] = player.name:match("(%w+)(.+)")
			append(color.blue, player.factionrank..""..names[2].." is now off duty.")
			append(color.rp, player.name.." changes out of their duty uniform.")
			anim.pskin = player.odskin; anim.pskin2 = player.odskin2; anim.pskin3 = player.odskin3
			player.factionduty = false
		end
		if player.factionid == 2 then
			if player.factionduty == false then append(color.gray, "You are already on duty."); return end
			local names = {}
			names[1], names[2] = player.name:match("(%w+)(.+)")
			append(color.dred, player.factionrank..""..names[2].." is now off duty.")
			append(color.rp, player.name.." changes out of their duty uniform.")
			anim.pskin = player.odskin; anim.pskin2 = player.odskin2; anim.pskin3 = player.odskin3
			player.factionduty = false
		end
		cmdisvalid = true
	end -- end of duty off
	if cmd == "duty" then
		if player.factionid ~= 1 and player.factionid ~= 2 then append(color.gray, "You are not a member of PPD or PFD."); return end
		if player.factionid == 1 or player.factionid == 2 then
		if player.factionduty == true then append(color.gray, "Usage: /duty [on/off] - You are currently ON duty.") end
		if player.factionduty == false then append(color.gray, "Usage: /duty [on/off] - You are currently OFF duty.") end
		end
		cmdisvalid = true
	end
	if cmd == "fcar" then
		if player.factionid == 1 then
			if player.factionduty == true then
				cscript.runcmd("/v cruiser1")
			else append(color.gray, "You are not on duty."); return
			end
		end
		if player.factionid == 2 then
			append(color.dred, "[debug] Ambulance not added, cannot spawn fcar!")
		end
		if player.factionid == 6 then
			cscript.runcmd("/v roadrunner")
			append(color.gray, "Trucking hauls are not added yet.")
		end
		if player.factionid ~= 1 and player.factionid ~= 2 and player.factionid ~= 6 then
			append(color.gray, "Your faction does not have any faction vehicles.")
		end
		cmdisvalid = true
	end
	-- NEW MARKER
	if string.find(cmd, "marker") then
		local hood = tonumber(string.match(cmd, "%d+"))
		local hname = "nil"
		local pos_x = 0; local pos_y = 0
		n.marker.hood = hood
		if hood == 1 then hname = "Coastal Bay" end
		if hood== 2 then hname = "Northmid" end
		if hood == 3 then hname = "Uptown" end
		if hood == 4 then hname = "El Corazon" end
		if hood == 5 then hname = "Downtown" end
		if hood == 6 then hname = "Mideast" end
		if hood == 7 then hname = "The Dockyards" end
		if hood == 8 then hname = "Southmid" end
		if hood == 9 then hname = "Parkwood" end
		if hood == nil then append(color.gray, "Useage: /marker [hood id] (1-9 only!)"); cmdisvalid = true; return end
		append(color.lgray, "New marker made in "..hname.."!")
		n.marker.active = true
		marker_new(pos_x, pos_y, 1, hood) -- todo: delivery locations
		if hood == city.hood then n.marker.draw = true end
		cmdisvalid = true
	end
	-- SJOB TEST
	if cmd == "deliver" then -- force start sidejob
		local atlocation = false
		if city.int == "sub" then
			jdata.begin(1, "food")
			atlocation = true
		end
		if city.hood == 7 then
			jdata.begin(1, "docks")
			atlocation = true
		end
		if atlocation == false then append(color.lgray, "You need to be at a delivery job location to start.") end
		cmdisvalid = true
	end
	if cmd == "jtest2" then -- force end sidejob
		jdata.finish(1, "food")
		cmdisvalid = true
	end
	-- spawn follower (mystic)
	if cmd == "follow1" then
		cmdisvalid = true
		pedlist.placefollow(1)
		cscript.runcmd("/get 0")
	end
	-- MANUEL MARKER CHECK
	if cmd == "mcheck" then
		cmdisvalid = true
		marker_check()
	end	
	if cmd == "xtest" then
		cmdisvalid = true
		-- custom test:
		pedlist.newped(peds.ped0, "Allison Claude", lg.newImage("skins/sprite/allie.png"), true, 100, 100, "civilian", "WFA", "A tall but thin woman. She seems very alert and energetic.")
		end
	-- NEXT CMD	
	returned = true
	--append(color.lblue, "CMDISVALID: "..tostring(cmdisvalid))
	-- UNRECOGNIZED INPUT/CMD
		if	returned == true and cmdisvalid == false and talkingto == nil then append(color.gray, "Imput/CMD '"..cmd.."' was not recognized or inquired.") end
	end -- END OF COMMAND PROCESSING
end
function append(shade, text)
msg.line0 = msg.line1; msg.line1 = msg.line2; msg.line2 = msg.line3; msg.line3 = msg.line4; msg.line4 = msg.line5; msg.line5 = msg.line6; msg.line6 = msg.line7; msg.line7 = msg.line8; msg.line8 = msg.line9; msg.line9 = text
msg.color0 = msg.color1; msg.color1 = msg.color2; msg.color2 = msg.color3; msg.color3 = msg.color4; msg.color4 = msg.color5; msg.color5 = msg.color6; msg.color6 = msg.color7; msg.color7 = msg.color8; msg.color8 = msg.color9; msg.color9 = shade
print(msg.line9)
end
print("[LOADED] cscript.lua")
return cscript