pedlist = {}
pedlist.gang0 = {" "}
pedlist.pd = {"James Hucken", "Veronica Alexandra", "Gary West", "Nicholas Piercen"}
pedlist.fd = {"Jordan Dupree", "Ethan O'Flynn", "Zeke Swiger", "Sarah Hayes"}
pedlist.gang1 = {"Tyrone Johnson", "Malik Kenwood", "Deshaun Marcus", "Shaniqua Kenwood"}
pedlist.gang2 = {"Javonte Mosely", "Antonio Mosely", "Isaiah Freeman", "Deshawna Browning"}
pedlist.gang3 = {"Ashley Vindago", "Jose Cortana", "Miguel Hernandez", "Jason Diego"}
pedlist.truck = {"Shaun Richard", "Trevor Oak", "Rebecca Gill", "Mitchell Torreto"}
pedlist.civ = {"Gary West", "Darren Thompson", "David Gallagher", "Sydney Keith"}
pedlist.sub = {"SUB-URBAN Employee"}
pedlist.qgas = {"Quickgas Employee"}
pedlist.gun = {"Allison Claude"}
pedlist.follow = {"Mystic LaFave"}

function pedlist.newped(path, name, skin, hasgun, hp, ap, faction, race, desc)
	local actualpath = string.match(tostring(path), "%d+")
	getpath(actualpath)
	getanimpath(actualpath)
	n.npcpath.name = name
	setpedskin(actualpath, skin)
	n.npcpath.hasgun = hasgun
	n.npcpath.hp = hp; n.npcpath.ap = ap
	n.npcpath.fac = faction
	n.npcpath.race = race
	n.npcpath.desc = desc
end

function pedlist.placegang(gang)
	if gang == 1 then
		ped.ped1.name = pedlist.gang1[1]
		anim.sprites.ped1.spriteSheet = (lg.newImage("skins/sprite/purp1.png"))
		ped.ped1.fac = "gang1"
		ped.ped2.name = pedlist.gang1[2]
		anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/purp1.png"))
		ped.ped2.fac = "gang1"
		ped.ped2.name = pedlist.gang1[3]
		anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/purp2.png"))
		ped.ped2.fac = "gang1"
		ped.ped4.name = pedlist.civ[4]
		anim.sprites.ped4.spriteSheet = (lg.newImage("skins/sprite/civ3.png"))
		ped.ped4.fac = "civilian"
	end
	if gang == 2 then
		ped.ped1.name = pedlist.gang2[1]
		anim.sprites.ped1.spriteSheet = (lg.newImage("skins/sprite/green2.png"))
		ped.ped1.fac = "gang2"
		ped.ped2.name = pedlist.gang2[2]
		anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/green2.png"))
		ped.ped2.fac = "gang2"
		ped.ped4.name = pedlist.gang2[3]
		anim.sprites.ped4.spriteSheet = (lg.newImage("skins/sprite/green3.png"))
		ped.ped4.fac = "gang2"
		ped.ped4.name = pedlist.civ[4]
	end
	if gang == 3 then
		ped.ped1.name = pedlist.gang3[1]
		ped.ped1.fac = "gang3"
		anim.sprites.ped1.spriteSheet = (lg.newImage("skins/sprite/blue1.png"))
		ped.ped2.name = pedlist.gang3[2]
		anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/blue1.png"))
		ped.ped2.fac = "gang3"
		ped.ped4.name = pedlist.gang3[3]
		anim.sprites.ped4.spriteSheet = (lg.newImage("skins/sprite/blue2.png"))
		ped.ped4.fac = "gang3"
		ped.ped8.name = pedlist.gang3[4]
		anim.sprites.ped8.spriteSheet = (lg.newImage("skins/sprite/civ3.png"))
		ped.ped8.fac = "gang3"
	end
	if gang == 4 then pedlist.place() end
	if gang == nil then
		if city.hood == "southmid" or city.hood == "parkwood" then pedlist.placegang(1); pedlist.placeciv() end
		if city.hood == "northmid" or city.hood == "northwest" then pedlist.placegang(2); pedlist.placeciv() end
		if city.hood == "southwest" or city.hood == "midwest" then pedlist.placegang(3); pedlist.placeciv() end
	end
end

function pedlist.placefd()
	ped.ped1.name = pedlist.fd[1]
	ped.ped1.fac = "fd"
	anim.sprites.ped1.spriteSheet = (lg.newImage("skins/sprite/emt1f.png"))
	ped.ped2.name = pedlist.fd[2]
	ped.ped2.fac = "fd"
	anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/emt1f.png"))
	ped.ped4.name = pedlist.fd[3]
	ped.ped4.fac = "fd"
	anim.sprites.ped4.spriteSheet = (lg.newImage("skins/sprite/emt1f.png"))
	ped.ped8.name = pedlist.fd[4]
	ped.ped8.fac = "fd"
	anim.sprites.ped8.spriteSheet = (lg.newImage("skins/sprite/emt1f.png"))
end

function pedlist.placepd()
	ped.ped3.name = pedlist.pd[1]
	anim.sprites.ped3.spriteSheet = (lg.newImage("skins/sprite/cop3.png"))
	ped.ped3.fac = "pd"
	ped.ped3.armed = true
	ped.ped3.hp = 200
	ped.ped5.name = pedlist.pd[2]
	anim.sprites.ped5.spriteSheet = (lg.newImage("skins/sprite/cop4.png"))
	ped.ped5.fac = "pd"
	ped.ped5.armed = true
	ped.ped5.hp = 200
	ped.ped6.name = pedlist.pd[4]
	anim.sprites.ped6.spriteSheet = (lg.newImage("skins/sprite/cop2.png"))
	ped.ped6.fac = "pd"
	ped.ped6.armed = true
	ped.ped6.hp = 200
end

function pedlist.placeciv()
	ped.ped7.name = pedlist.civ[1]
	ped.ped7.fac = "civilian"
	anim.sprites.ped9.spriteSheet = (lg.newImage("skins/sprite/civ1.png"))
	ped.ped9.name = pedlist.civ[2]
	ped.ped9.fac = "civilian"
	anim.sprites.ped9.spriteSheet = (lg.newImage("skins/sprite/civ2.png"))
	ped.ped0.name = pedlist.civ[3]
	ped.ped0.fac = "civilian"
	anim.sprites.ped0.spriteSheet = (lg.newImage("skins/sprite/civ1.png"))
end

function pedlist.placefollow(follower)
		ped.ped0.name = pedlist.follow[follower]
		peds.ped0.hp = 100
		peds.ped0.ap = 50
		if follower == 1 then
			peds.ped0.dealer = true
			peds.ped0.fac = "dealer"
			peds.ped0.race = "wfa"
			peds.ped0.armed = true
			peds.ped0.holstered = true
			peds.ped0.weapon = txtrs.weapons.glockf
			anim.sprites.ped0 = newAnimation(lg.newImage("skins/sprite/mystic.png"), 40, 65, 150)
		end
			append(color.lblue, "Converted ped0 to follower: ["..ped.ped0.name.."] (#"..follower..")")
end

function pedlist.place(gang)
pedlist.placegang(gang)
pedlist.placepd()
pedlist.placeciv()
end

function pedlist.placeint(int)
	if int == "gun" then
		pedlist.placenone()
		ped.ped0.name = pedlist.gun[1]
		ped.ped0.x = 35; ped.ped0.y = 100
		ped.ped0.fac = "civilian"
		anim.sprites.ped0.spriteSheet = (lg.newImage("skins/sprite/allie.png"))
	end
	if int == "sub" then
		pedlist.placenone()
		ped.ped0.name = pedlist.sub[1]
		ped.ped0.x = 35; ped.ped0.y = 100
		ped.ped0.fac = "civilian"
		anim.sprites.ped0.spriteSheet = (lg.newImage("skins/sprite/surb1.png"))
	end
	if int == "qgas" then
		pedlist.placenone()
		ped.ped0.name = pedlist.qgas[1]
		ped.ped0.x = 100; ped.ped0.y = 225
		ped.ped0.fac = "QuickGas Employee"
		local gskin1 = love.math.random(1,3)
		local gskin2 = love.math.random(1,3)
		local cskin = love.math.random(1,5)
		if gskin1 == gskin2 then
			gskin2 = gskin1 + 1
			if gskin2 == 4 then
				gskin2 = 1
			end
		end
		anim.sprites.ped0.spriteSheet = (lg.newImage("skins/sprite/qgas1.png"))
		anim.sprites.ped1.spriteSheet = (lg.newImage("skins/sprite/purp"..gskin1..".png"))
		anim.sprites.ped2.spriteSheet = (lg.newImage("skins/sprite/purp"..gskin2..".png"))
		anim.sprites.ped3.spriteSheet = (lg.newImage("skins/sprite/civ"..cskin..".png"))
		ped.ped1.x = 225; ped.ped1.y = 50
		ped.ped2.x = 450; ped.ped2.y = 125
		ped.ped3.x = 435; ped.ped3.y = 0
		ped.ped3.name = pedlist.civ[love.math.random(1,4)]
	end
end

function pedlist.placenone()
	ped.ped0.x = -999; ped.ped0.y = -999
	ped.ped1.x = -999; ped.ped1.y = -999
	ped.ped2.x = -999; ped.ped2.y = -999
	ped.ped3.x = -999; ped.ped3.y = -999
	ped.ped4.x = -999; ped.ped4.y = -999
	ped.ped5.x = -999; ped.ped5.y = -999
	ped.ped6.x = -999; ped.ped6.y = -999
	ped.ped7.x = -999; ped.ped7.y = -999
	ped.ped8.x = -999; ped.ped8.y = -999
	ped.ped9.x = -999; ped.ped9.y = -999
end
print("[LOADED] pedlist.lua")
return pedlist