event = {}
event.timer = 0
event.timer2 = 0
event.timer_max = 2
event.timer_max2 = 2
event.doupdate = false
event.leftorright = nil
event.upordown = nil
event.ped = nil
event.etype = nil
event.arg1 = nil
event.arg2 = nil
event.eventcode = "nil"
-- TYPES- (0) nil/off (1) ped walking (2) ped driving (3) ped chatting (4) ped exiting scene

function love.update()
		
	end -- end of if love's update function

function event.new(etype, ped, farg1, farg2)
	local etypestring = "nil"
	event.arg1 = farg1
	event.arg2 = farg2
	event.ped = ped
	event.etype = etype
	if etype == 0 then
		etypestring = "off"
		print(color.lblue, "[event] nil event run - check etype?")
		return
	end
	if etype == 1 then
		etypestring = "walk"
	end
	if etype == 2 then
		etypestring = "drive"
		local vehspeed = 400
		local vehtype = love.math.random(1,4)
		if vehtype == 1 then graphics.npcveh1_active = true; graphics.npcveh1_txtr = txtrs.vehs.cruiser1 end
		if vehtype == 1 then graphics.npcveh1_active = true; graphics.npcveh1_txtr = txtrs.vehs.cruiser2 end
		if vehtype == 3 or vehtype == 4 then graphics.npcveh1_active = true; graphics.npcveh1_txtr = txtrs.vehs.cab1 end -- cab most likely
		graphics.npcveh1_x = player.x; graphics.npcveh1_y = player.y
		print("[drive event] vehpos: "..graphics.npcveh1_x..", "..graphics.npcveh1_y)
		-- (roadrunner)
		-- average sedan
		-- pickup truck
		-- work van
		-- muscle car
		event.eventcode = "drivewait"; event.timer_max = vehspeed; event.timer = 0
		event.doupdate = true
		print("[event] NEW DRIVEWAIT EVENT! direction: ["..farg1.."], speed: ["..farg2.."], vehtype: "..vehtype..", vehspeed: "..vehspeed.." ticks")
	end
	if etype == 3 then
		etypestring = "chat"
	end
	if etype == 4 then
		etypestring = "exit"
	end
	if etype == 5 then
		local fishwaittime = love.math.random(150, 500)
		etypestring = "fishwait"; event.eventcode = "fishwait"; event.timer_max = fishwaittime; event.timer = 0; event.doupdate = true
		print("[event] NEW FISHWAIT EVENT! fishwaittime: "..fishwaittime.." ticks")
	end
	if etype == 6 then -- dmg indicator - etype, ped, farg1, farg2
		local dur = 100
		etypestring = "dmgind"
		print("[event] NEW DMG INDICATOR EVENT! duration: "..dur)
		event.timer2 = 0; event.timer_max2 = dur
	end
	-- events
	print("[event] NEW EVENT! Type "..etype.." ("..etypestring..")")
	if etypestring == "dmgind" then
		event.timer2 = event.timer2 + 1
		if event.timer2 >= event.timer_max2 then
			n.dmgind_on = false
			n.dmgind = 0
			event.timer2 = 0
		end
	end
	if etypestring == "walk" then
		getpath2(ped)
		print("[event, walk] preparing walk event on ID "..ped)	
		local pedisat_x = n.npcpath.x 
		local pedisat_y = n.npcpath.y
		local distance_x = farg1 - pedisat_x
		local distance_y = farg2 - pedisat_y
		event.leftorright = nil
		--print("[event, walk] pedx: "..n.npcpath.x.." pedy: "..n.npcpath.y.." targetx: "..event.arg1..", targety: "..event.arg2)
		--print("[event, walk] distance_x: "..distance_x)
		event.arg1 = farg1; event.arg2 = farg2
		if distance_x < 0 then event.leftorright = "left" end
		if distance_x > 0 then event.leftorright = "right" end
		if distance_y < 0 then event.upordown = "up" end
		if distance_y > 0 then event.upordown = "down" end
		getanimpath(ped)
		if event.upordown == "up" then
			print("[event, walk] Y distance is negative, ped "..ped.." must move up!")
			event.doupdate = false
		end
		if event.upordown == "down" then
			print("[event, walk] Y distance is positive, ped "..ped.." must move down!")
			event.doupdate = false
		end
		if event.leftorright == "left" then
			print("[event, walk] X distance is negative, ped "..ped.." must move left!")
			event.doupdate = true
			return
		end -- end of if need to move left
		if event.leftorright == "right" then
			print("[event, walk] X distance is positive, ped "..ped.." must move right!")
			event.doupdate = true
			event.timer = 0
			event.timer_max = 1
			return
		end
		if event.doupdate == true then return end
	end -- end of if etype walk
	if etypestring == "exit" then
		getpath2(ped)
		print("[event, exit] removing ped from scene")
		n.npcpath.x = 999
		n.npcpath.y = 999
		updatetags()
	end
end -- end of new  
print("[LOADED] event.lua")
return event